import Long from "long";
import { ChannelCredentials, ChannelOptions, UntypedServiceImplementation, handleUnaryCall, Client, ClientUnaryCall, Metadata, CallOptions, ServiceError } from "@grpc/grpc-js";
import * as _m0 from "protobufjs/minimal";
import { DataEntry } from "../data_entry";
import { Empty } from "../google/protobuf/empty";
import { AddressesResponse } from "../entity/address";
export declare const protobufPackage = "wavesenterprise.grpc";
export interface AddressDataRequest {
    address?: string;
    limit?: number;
    offset?: number;
}
export interface AddressDataByKeyRequest {
    address?: string;
    key?: string;
}
export interface AddressDataResponse {
    entries?: DataEntry[];
}
export declare const AddressDataRequest: {
    encode(message: AddressDataRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): AddressDataRequest;
    fromJSON(object: any): AddressDataRequest;
    toJSON(message: AddressDataRequest): unknown;
    fromPartial(object: DeepPartial<AddressDataRequest>): AddressDataRequest;
};
export declare const AddressDataByKeyRequest: {
    encode(message: AddressDataByKeyRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): AddressDataByKeyRequest;
    fromJSON(object: any): AddressDataByKeyRequest;
    toJSON(message: AddressDataByKeyRequest): unknown;
    fromPartial(object: DeepPartial<AddressDataByKeyRequest>): AddressDataByKeyRequest;
};
export declare const AddressDataResponse: {
    encode(message: AddressDataResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): AddressDataResponse;
    fromJSON(object: any): AddressDataResponse;
    toJSON(message: AddressDataResponse): unknown;
    fromPartial(object: DeepPartial<AddressDataResponse>): AddressDataResponse;
};
export declare const AddressPublicServiceService: {
    readonly getAddresses: {
        readonly path: "/wavesenterprise.grpc.AddressPublicService/GetAddresses";
        readonly requestStream: false;
        readonly responseStream: false;
        readonly requestSerialize: (value: Empty) => Buffer;
        readonly requestDeserialize: (value: Buffer) => Empty;
        readonly responseSerialize: (value: AddressesResponse) => Buffer;
        readonly responseDeserialize: (value: Buffer) => AddressesResponse;
    };
    readonly getAddressData: {
        readonly path: "/wavesenterprise.grpc.AddressPublicService/GetAddressData";
        readonly requestStream: false;
        readonly responseStream: false;
        readonly requestSerialize: (value: AddressDataRequest) => Buffer;
        readonly requestDeserialize: (value: Buffer) => AddressDataRequest;
        readonly responseSerialize: (value: AddressDataResponse) => Buffer;
        readonly responseDeserialize: (value: Buffer) => AddressDataResponse;
    };
    readonly getAddressDataByKey: {
        readonly path: "/wavesenterprise.grpc.AddressPublicService/GetAddressDataByKey";
        readonly requestStream: false;
        readonly responseStream: false;
        readonly requestSerialize: (value: AddressDataByKeyRequest) => Buffer;
        readonly requestDeserialize: (value: Buffer) => AddressDataByKeyRequest;
        readonly responseSerialize: (value: AddressDataResponse) => Buffer;
        readonly responseDeserialize: (value: Buffer) => AddressDataResponse;
    };
};
export interface AddressPublicServiceServer extends UntypedServiceImplementation {
    getAddresses: handleUnaryCall<Empty, AddressesResponse>;
    getAddressData: handleUnaryCall<AddressDataRequest, AddressDataResponse>;
    getAddressDataByKey: handleUnaryCall<AddressDataByKeyRequest, AddressDataResponse>;
}
export interface AddressPublicServiceClient extends Client {
    getAddresses(request: Empty, callback: (error: ServiceError | null, response: AddressesResponse) => void): ClientUnaryCall;
    getAddresses(request: Empty, metadata: Metadata, callback: (error: ServiceError | null, response: AddressesResponse) => void): ClientUnaryCall;
    getAddresses(request: Empty, metadata: Metadata, options: Partial<CallOptions>, callback: (error: ServiceError | null, response: AddressesResponse) => void): ClientUnaryCall;
    getAddressData(request: AddressDataRequest, callback: (error: ServiceError | null, response: AddressDataResponse) => void): ClientUnaryCall;
    getAddressData(request: AddressDataRequest, metadata: Metadata, callback: (error: ServiceError | null, response: AddressDataResponse) => void): ClientUnaryCall;
    getAddressData(request: AddressDataRequest, metadata: Metadata, options: Partial<CallOptions>, callback: (error: ServiceError | null, response: AddressDataResponse) => void): ClientUnaryCall;
    getAddressDataByKey(request: AddressDataByKeyRequest, callback: (error: ServiceError | null, response: AddressDataResponse) => void): ClientUnaryCall;
    getAddressDataByKey(request: AddressDataByKeyRequest, metadata: Metadata, callback: (error: ServiceError | null, response: AddressDataResponse) => void): ClientUnaryCall;
    getAddressDataByKey(request: AddressDataByKeyRequest, metadata: Metadata, options: Partial<CallOptions>, callback: (error: ServiceError | null, response: AddressDataResponse) => void): ClientUnaryCall;
}
export declare const AddressPublicServiceClient: {
    new (address: string, credentials: ChannelCredentials, options?: Partial<ChannelOptions>): AddressPublicServiceClient;
    service: typeof AddressPublicServiceService;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
