import Long from "long";
import { ChannelCredentials, ChannelOptions, UntypedServiceImplementation, handleUnaryCall, Client, ClientUnaryCall, Metadata, CallOptions, ServiceError } from "@grpc/grpc-js";
import * as _m0 from "protobufjs/minimal";
import { AddressResponse, AddressRequest } from "../entity/address";
export declare const protobufPackage = "wavesenterprise.grpc";
export interface AliasRequest {
    alias?: string;
}
export interface AliasesResponse {
    aliases?: string[];
}
export declare const AliasRequest: {
    encode(message: AliasRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): AliasRequest;
    fromJSON(object: any): AliasRequest;
    toJSON(message: AliasRequest): unknown;
    fromPartial(object: DeepPartial<AliasRequest>): AliasRequest;
};
export declare const AliasesResponse: {
    encode(message: AliasesResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): AliasesResponse;
    fromJSON(object: any): AliasesResponse;
    toJSON(message: AliasesResponse): unknown;
    fromPartial(object: DeepPartial<AliasesResponse>): AliasesResponse;
};
export declare const AliasPublicServiceService: {
    readonly addressByAlias: {
        readonly path: "/wavesenterprise.grpc.AliasPublicService/AddressByAlias";
        readonly requestStream: false;
        readonly responseStream: false;
        readonly requestSerialize: (value: AliasRequest) => Buffer;
        readonly requestDeserialize: (value: Buffer) => AliasRequest;
        readonly responseSerialize: (value: AddressResponse) => Buffer;
        readonly responseDeserialize: (value: Buffer) => AddressResponse;
    };
    readonly aliasesByAddress: {
        readonly path: "/wavesenterprise.grpc.AliasPublicService/AliasesByAddress";
        readonly requestStream: false;
        readonly responseStream: false;
        readonly requestSerialize: (value: AddressRequest) => Buffer;
        readonly requestDeserialize: (value: Buffer) => AddressRequest;
        readonly responseSerialize: (value: AliasesResponse) => Buffer;
        readonly responseDeserialize: (value: Buffer) => AliasesResponse;
    };
};
export interface AliasPublicServiceServer extends UntypedServiceImplementation {
    addressByAlias: handleUnaryCall<AliasRequest, AddressResponse>;
    aliasesByAddress: handleUnaryCall<AddressRequest, AliasesResponse>;
}
export interface AliasPublicServiceClient extends Client {
    addressByAlias(request: AliasRequest, callback: (error: ServiceError | null, response: AddressResponse) => void): ClientUnaryCall;
    addressByAlias(request: AliasRequest, metadata: Metadata, callback: (error: ServiceError | null, response: AddressResponse) => void): ClientUnaryCall;
    addressByAlias(request: AliasRequest, metadata: Metadata, options: Partial<CallOptions>, callback: (error: ServiceError | null, response: AddressResponse) => void): ClientUnaryCall;
    aliasesByAddress(request: AddressRequest, callback: (error: ServiceError | null, response: AliasesResponse) => void): ClientUnaryCall;
    aliasesByAddress(request: AddressRequest, metadata: Metadata, callback: (error: ServiceError | null, response: AliasesResponse) => void): ClientUnaryCall;
    aliasesByAddress(request: AddressRequest, metadata: Metadata, options: Partial<CallOptions>, callback: (error: ServiceError | null, response: AliasesResponse) => void): ClientUnaryCall;
}
export declare const AliasPublicServiceClient: {
    new (address: string, credentials: ChannelCredentials, options?: Partial<ChannelOptions>): AliasPublicServiceClient;
    service: typeof AliasPublicServiceService;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
