"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.pkiModeToJSON = exports.pkiModeFromJSON = exports.PkiMode = exports.consensusTypeToJSON = exports.consensusTypeFromJSON = exports.ConsensusType = exports.cryptoTypeToJSON = exports.cryptoTypeFromJSON = exports.CryptoType = exports.cryptoAlgoToJSON = exports.cryptoAlgoFromJSON = exports.CryptoAlgo = exports.protobufPackage = void 0;
const long_1 = __importDefault(require("long"));
const _m0 = __importStar(require("protobufjs/minimal"));
exports.protobufPackage = "wavesenterprise";
var CryptoAlgo;
(function (CryptoAlgo) {
    CryptoAlgo[CryptoAlgo["UNKNOWN_CRYPTO_ALGO"] = 0] = "UNKNOWN_CRYPTO_ALGO";
    CryptoAlgo[CryptoAlgo["GOST_3412_2015_K"] = 2] = "GOST_3412_2015_K";
    CryptoAlgo[CryptoAlgo["AES"] = 3] = "AES";
    CryptoAlgo[CryptoAlgo["UNRECOGNIZED"] = -1] = "UNRECOGNIZED";
})(CryptoAlgo = exports.CryptoAlgo || (exports.CryptoAlgo = {}));
function cryptoAlgoFromJSON(object) {
    switch (object) {
        case 0:
        case "UNKNOWN_CRYPTO_ALGO":
            return CryptoAlgo.UNKNOWN_CRYPTO_ALGO;
        case 2:
        case "GOST_3412_2015_K":
            return CryptoAlgo.GOST_3412_2015_K;
        case 3:
        case "AES":
            return CryptoAlgo.AES;
        case -1:
        case "UNRECOGNIZED":
        default:
            return CryptoAlgo.UNRECOGNIZED;
    }
}
exports.cryptoAlgoFromJSON = cryptoAlgoFromJSON;
function cryptoAlgoToJSON(object) {
    switch (object) {
        case CryptoAlgo.UNKNOWN_CRYPTO_ALGO:
            return "UNKNOWN_CRYPTO_ALGO";
        case CryptoAlgo.GOST_3412_2015_K:
            return "GOST_3412_2015_K";
        case CryptoAlgo.AES:
            return "AES";
        default:
            return "UNKNOWN";
    }
}
exports.cryptoAlgoToJSON = cryptoAlgoToJSON;
var CryptoType;
(function (CryptoType) {
    CryptoType[CryptoType["UNKNOWN_CRYPTO_TYPE"] = 0] = "UNKNOWN_CRYPTO_TYPE";
    CryptoType[CryptoType["GOST"] = 1] = "GOST";
    CryptoType[CryptoType["CURVE_25519"] = 2] = "CURVE_25519";
    CryptoType[CryptoType["UNRECOGNIZED"] = -1] = "UNRECOGNIZED";
})(CryptoType = exports.CryptoType || (exports.CryptoType = {}));
function cryptoTypeFromJSON(object) {
    switch (object) {
        case 0:
        case "UNKNOWN_CRYPTO_TYPE":
            return CryptoType.UNKNOWN_CRYPTO_TYPE;
        case 1:
        case "GOST":
            return CryptoType.GOST;
        case 2:
        case "CURVE_25519":
            return CryptoType.CURVE_25519;
        case -1:
        case "UNRECOGNIZED":
        default:
            return CryptoType.UNRECOGNIZED;
    }
}
exports.cryptoTypeFromJSON = cryptoTypeFromJSON;
function cryptoTypeToJSON(object) {
    switch (object) {
        case CryptoType.UNKNOWN_CRYPTO_TYPE:
            return "UNKNOWN_CRYPTO_TYPE";
        case CryptoType.GOST:
            return "GOST";
        case CryptoType.CURVE_25519:
            return "CURVE_25519";
        default:
            return "UNKNOWN";
    }
}
exports.cryptoTypeToJSON = cryptoTypeToJSON;
var ConsensusType;
(function (ConsensusType) {
    ConsensusType[ConsensusType["UNKNOWN_CONSENSUS_TYPE"] = 0] = "UNKNOWN_CONSENSUS_TYPE";
    ConsensusType[ConsensusType["POA"] = 1] = "POA";
    ConsensusType[ConsensusType["POS"] = 2] = "POS";
    ConsensusType[ConsensusType["CFT"] = 3] = "CFT";
    ConsensusType[ConsensusType["UNRECOGNIZED"] = -1] = "UNRECOGNIZED";
})(ConsensusType = exports.ConsensusType || (exports.ConsensusType = {}));
function consensusTypeFromJSON(object) {
    switch (object) {
        case 0:
        case "UNKNOWN_CONSENSUS_TYPE":
            return ConsensusType.UNKNOWN_CONSENSUS_TYPE;
        case 1:
        case "POA":
            return ConsensusType.POA;
        case 2:
        case "POS":
            return ConsensusType.POS;
        case 3:
        case "CFT":
            return ConsensusType.CFT;
        case -1:
        case "UNRECOGNIZED":
        default:
            return ConsensusType.UNRECOGNIZED;
    }
}
exports.consensusTypeFromJSON = consensusTypeFromJSON;
function consensusTypeToJSON(object) {
    switch (object) {
        case ConsensusType.UNKNOWN_CONSENSUS_TYPE:
            return "UNKNOWN_CONSENSUS_TYPE";
        case ConsensusType.POA:
            return "POA";
        case ConsensusType.POS:
            return "POS";
        case ConsensusType.CFT:
            return "CFT";
        default:
            return "UNKNOWN";
    }
}
exports.consensusTypeToJSON = consensusTypeToJSON;
var PkiMode;
(function (PkiMode) {
    PkiMode[PkiMode["UNKNOWN_PKI_MODE"] = 0] = "UNKNOWN_PKI_MODE";
    PkiMode[PkiMode["ON"] = 1] = "ON";
    PkiMode[PkiMode["OFF"] = 2] = "OFF";
    PkiMode[PkiMode["TEST"] = 3] = "TEST";
    PkiMode[PkiMode["UNRECOGNIZED"] = -1] = "UNRECOGNIZED";
})(PkiMode = exports.PkiMode || (exports.PkiMode = {}));
function pkiModeFromJSON(object) {
    switch (object) {
        case 0:
        case "UNKNOWN_PKI_MODE":
            return PkiMode.UNKNOWN_PKI_MODE;
        case 1:
        case "ON":
            return PkiMode.ON;
        case 2:
        case "OFF":
            return PkiMode.OFF;
        case 3:
        case "TEST":
            return PkiMode.TEST;
        case -1:
        case "UNRECOGNIZED":
        default:
            return PkiMode.UNRECOGNIZED;
    }
}
exports.pkiModeFromJSON = pkiModeFromJSON;
function pkiModeToJSON(object) {
    switch (object) {
        case PkiMode.UNKNOWN_PKI_MODE:
            return "UNKNOWN_PKI_MODE";
        case PkiMode.ON:
            return "ON";
        case PkiMode.OFF:
            return "OFF";
        case PkiMode.TEST:
            return "TEST";
        default:
            return "UNKNOWN";
    }
}
exports.pkiModeToJSON = pkiModeToJSON;
if (_m0.util.Long !== long_1.default) {
    _m0.util.Long = long_1.default;
    _m0.configure();
}
//# sourceMappingURL=constants.js.map