import Long from "long";
import { ChannelCredentials, ChannelOptions, UntypedServiceImplementation, handleUnaryCall, Client, ClientUnaryCall, Metadata, CallOptions, ServiceError } from "@grpc/grpc-js";
import * as _m0 from "protobufjs/minimal";
import { DataEntry } from "../data_entry";
import { Empty } from "../google/protobuf/empty";
export declare const protobufPackage = "wavesenterprise";
export interface AddressesResponse {
    addresses?: string[];
}
export interface AddressDataRequest {
    address?: string;
    limit?: number;
    offset?: number;
}
export interface AddressDataResponse {
    entries?: DataEntry[];
}
export interface AssetBalanceRequest {
    address?: Uint8Array;
    assetId?: Uint8Array;
}
export interface AssetBalanceResponse {
    assetId?: Uint8Array;
    amount?: Long;
    decimals?: number;
}
export declare const AddressesResponse: {
    encode(message: AddressesResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): AddressesResponse;
    fromJSON(object: any): AddressesResponse;
    toJSON(message: AddressesResponse): unknown;
    fromPartial(object: DeepPartial<AddressesResponse>): AddressesResponse;
};
export declare const AddressDataRequest: {
    encode(message: AddressDataRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): AddressDataRequest;
    fromJSON(object: any): AddressDataRequest;
    toJSON(message: AddressDataRequest): unknown;
    fromPartial(object: DeepPartial<AddressDataRequest>): AddressDataRequest;
};
export declare const AddressDataResponse: {
    encode(message: AddressDataResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): AddressDataResponse;
    fromJSON(object: any): AddressDataResponse;
    toJSON(message: AddressDataResponse): unknown;
    fromPartial(object: DeepPartial<AddressDataResponse>): AddressDataResponse;
};
export declare const AssetBalanceRequest: {
    encode(message: AssetBalanceRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): AssetBalanceRequest;
    fromJSON(object: any): AssetBalanceRequest;
    toJSON(message: AssetBalanceRequest): unknown;
    fromPartial(object: DeepPartial<AssetBalanceRequest>): AssetBalanceRequest;
};
export declare const AssetBalanceResponse: {
    encode(message: AssetBalanceResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): AssetBalanceResponse;
    fromJSON(object: any): AssetBalanceResponse;
    toJSON(message: AssetBalanceResponse): unknown;
    fromPartial(object: DeepPartial<AssetBalanceResponse>): AssetBalanceResponse;
};
export declare const AddressServiceService: {
    readonly getAddresses: {
        readonly path: "/wavesenterprise.AddressService/GetAddresses";
        readonly requestStream: false;
        readonly responseStream: false;
        readonly requestSerialize: (value: Empty) => Buffer;
        readonly requestDeserialize: (value: Buffer) => Empty;
        readonly responseSerialize: (value: AddressesResponse) => Buffer;
        readonly responseDeserialize: (value: Buffer) => AddressesResponse;
    };
    readonly getAddressData: {
        readonly path: "/wavesenterprise.AddressService/GetAddressData";
        readonly requestStream: false;
        readonly responseStream: false;
        readonly requestSerialize: (value: AddressDataRequest) => Buffer;
        readonly requestDeserialize: (value: Buffer) => AddressDataRequest;
        readonly responseSerialize: (value: AddressDataResponse) => Buffer;
        readonly responseDeserialize: (value: Buffer) => AddressDataResponse;
    };
    readonly getAssetBalance: {
        readonly path: "/wavesenterprise.AddressService/GetAssetBalance";
        readonly requestStream: false;
        readonly responseStream: false;
        readonly requestSerialize: (value: AssetBalanceRequest) => Buffer;
        readonly requestDeserialize: (value: Buffer) => AssetBalanceRequest;
        readonly responseSerialize: (value: AssetBalanceResponse) => Buffer;
        readonly responseDeserialize: (value: Buffer) => AssetBalanceResponse;
    };
};
export interface AddressServiceServer extends UntypedServiceImplementation {
    getAddresses: handleUnaryCall<Empty, AddressesResponse>;
    getAddressData: handleUnaryCall<AddressDataRequest, AddressDataResponse>;
    getAssetBalance: handleUnaryCall<AssetBalanceRequest, AssetBalanceResponse>;
}
export interface AddressServiceClient extends Client {
    getAddresses(request: Empty, callback: (error: ServiceError | null, response: AddressesResponse) => void): ClientUnaryCall;
    getAddresses(request: Empty, metadata: Metadata, callback: (error: ServiceError | null, response: AddressesResponse) => void): ClientUnaryCall;
    getAddresses(request: Empty, metadata: Metadata, options: Partial<CallOptions>, callback: (error: ServiceError | null, response: AddressesResponse) => void): ClientUnaryCall;
    getAddressData(request: AddressDataRequest, callback: (error: ServiceError | null, response: AddressDataResponse) => void): ClientUnaryCall;
    getAddressData(request: AddressDataRequest, metadata: Metadata, callback: (error: ServiceError | null, response: AddressDataResponse) => void): ClientUnaryCall;
    getAddressData(request: AddressDataRequest, metadata: Metadata, options: Partial<CallOptions>, callback: (error: ServiceError | null, response: AddressDataResponse) => void): ClientUnaryCall;
    getAssetBalance(request: AssetBalanceRequest, callback: (error: ServiceError | null, response: AssetBalanceResponse) => void): ClientUnaryCall;
    getAssetBalance(request: AssetBalanceRequest, metadata: Metadata, callback: (error: ServiceError | null, response: AssetBalanceResponse) => void): ClientUnaryCall;
    getAssetBalance(request: AssetBalanceRequest, metadata: Metadata, options: Partial<CallOptions>, callback: (error: ServiceError | null, response: AssetBalanceResponse) => void): ClientUnaryCall;
}
export declare const AddressServiceClient: {
    new (address: string, credentials: ChannelCredentials, options?: Partial<ChannelOptions>): AddressServiceClient;
    service: typeof AddressServiceService;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
