"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AddressServiceClient = exports.AddressServiceService = exports.AssetBalanceResponse = exports.AssetBalanceRequest = exports.AddressDataResponse = exports.AddressDataRequest = exports.AddressesResponse = exports.protobufPackage = void 0;
const long_1 = __importDefault(require("long"));
const grpc_js_1 = require("@grpc/grpc-js");
const _m0 = __importStar(require("protobufjs/minimal"));
const data_entry_1 = require("../data_entry");
const empty_1 = require("../google/protobuf/empty");
const wrappers_1 = require("../google/protobuf/wrappers");
exports.protobufPackage = "wavesenterprise";
function createBaseAddressesResponse() {
    return { addresses: [] };
}
exports.AddressesResponse = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.addresses !== undefined && message.addresses.length !== 0) {
            for (const v of message.addresses) {
                writer.uint32(10).string(v);
            }
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseAddressesResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.addresses.push(reader.string());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            addresses: Array.isArray(object === null || object === void 0 ? void 0 : object.addresses)
                ? object.addresses.map((e) => String(e))
                : [],
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.addresses) {
            obj.addresses = message.addresses.map((e) => e);
        }
        else {
            obj.addresses = [];
        }
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseAddressesResponse();
        message.addresses = ((_a = object.addresses) === null || _a === void 0 ? void 0 : _a.map((e) => e)) || [];
        return message;
    },
};
function createBaseAddressDataRequest() {
    return { address: "", limit: undefined, offset: undefined };
}
exports.AddressDataRequest = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.address !== undefined && message.address !== "") {
            writer.uint32(10).string(message.address);
        }
        if (message.limit !== undefined) {
            wrappers_1.Int32Value.encode({ value: message.limit }, writer.uint32(18).fork()).ldelim();
        }
        if (message.offset !== undefined) {
            wrappers_1.Int32Value.encode({ value: message.offset }, writer.uint32(26).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseAddressDataRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.address = reader.string();
                    break;
                case 2:
                    message.limit = wrappers_1.Int32Value.decode(reader, reader.uint32()).value;
                    break;
                case 3:
                    message.offset = wrappers_1.Int32Value.decode(reader, reader.uint32()).value;
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            address: isSet(object.address) ? String(object.address) : "",
            limit: isSet(object.limit) ? Number(object.limit) : undefined,
            offset: isSet(object.offset) ? Number(object.offset) : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.address !== undefined && (obj.address = message.address);
        message.limit !== undefined && (obj.limit = message.limit);
        message.offset !== undefined && (obj.offset = message.offset);
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c;
        const message = createBaseAddressDataRequest();
        message.address = (_a = object.address) !== null && _a !== void 0 ? _a : "";
        message.limit = (_b = object.limit) !== null && _b !== void 0 ? _b : undefined;
        message.offset = (_c = object.offset) !== null && _c !== void 0 ? _c : undefined;
        return message;
    },
};
function createBaseAddressDataResponse() {
    return { entries: [] };
}
exports.AddressDataResponse = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.entries !== undefined && message.entries.length !== 0) {
            for (const v of message.entries) {
                data_entry_1.DataEntry.encode(v, writer.uint32(10).fork()).ldelim();
            }
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseAddressDataResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.entries.push(data_entry_1.DataEntry.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            entries: Array.isArray(object === null || object === void 0 ? void 0 : object.entries)
                ? object.entries.map((e) => data_entry_1.DataEntry.fromJSON(e))
                : [],
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.entries) {
            obj.entries = message.entries.map((e) => e ? data_entry_1.DataEntry.toJSON(e) : undefined);
        }
        else {
            obj.entries = [];
        }
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseAddressDataResponse();
        message.entries =
            ((_a = object.entries) === null || _a === void 0 ? void 0 : _a.map((e) => data_entry_1.DataEntry.fromPartial(e))) || [];
        return message;
    },
};
function createBaseAssetBalanceRequest() {
    return { address: new Uint8Array(), assetId: undefined };
}
exports.AssetBalanceRequest = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.address !== undefined && message.address.length !== 0) {
            writer.uint32(10).bytes(message.address);
        }
        if (message.assetId !== undefined) {
            wrappers_1.BytesValue.encode({ value: message.assetId }, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseAssetBalanceRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.address = reader.bytes();
                    break;
                case 2:
                    message.assetId = wrappers_1.BytesValue.decode(reader, reader.uint32()).value;
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            address: isSet(object.address)
                ? bytesFromBase64(object.address)
                : new Uint8Array(),
            assetId: isSet(object.assetId)
                ? new Uint8Array(object.assetId)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.address !== undefined &&
            (obj.address = base64FromBytes(message.address !== undefined ? message.address : new Uint8Array()));
        message.assetId !== undefined && (obj.assetId = message.assetId);
        return obj;
    },
    fromPartial(object) {
        var _a, _b;
        const message = createBaseAssetBalanceRequest();
        message.address = (_a = object.address) !== null && _a !== void 0 ? _a : new Uint8Array();
        message.assetId = (_b = object.assetId) !== null && _b !== void 0 ? _b : undefined;
        return message;
    },
};
function createBaseAssetBalanceResponse() {
    return { assetId: undefined, amount: long_1.default.ZERO, decimals: 0 };
}
exports.AssetBalanceResponse = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.assetId !== undefined) {
            wrappers_1.BytesValue.encode({ value: message.assetId }, writer.uint32(10).fork()).ldelim();
        }
        if (message.amount !== undefined && !message.amount.isZero()) {
            writer.uint32(16).int64(message.amount);
        }
        if (message.decimals !== undefined && message.decimals !== 0) {
            writer.uint32(24).int32(message.decimals);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseAssetBalanceResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.assetId = wrappers_1.BytesValue.decode(reader, reader.uint32()).value;
                    break;
                case 2:
                    message.amount = reader.int64();
                    break;
                case 3:
                    message.decimals = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            assetId: isSet(object.assetId)
                ? new Uint8Array(object.assetId)
                : undefined,
            amount: isSet(object.amount) ? long_1.default.fromString(object.amount) : long_1.default.ZERO,
            decimals: isSet(object.decimals) ? Number(object.decimals) : 0,
        };
    },
    toJSON(message) {
        const obj = {};
        message.assetId !== undefined && (obj.assetId = message.assetId);
        message.amount !== undefined &&
            (obj.amount = (message.amount || long_1.default.ZERO).toString());
        message.decimals !== undefined &&
            (obj.decimals = Math.round(message.decimals));
        return obj;
    },
    fromPartial(object) {
        var _a, _b;
        const message = createBaseAssetBalanceResponse();
        message.assetId = (_a = object.assetId) !== null && _a !== void 0 ? _a : undefined;
        message.amount =
            object.amount !== undefined && object.amount !== null
                ? long_1.default.fromValue(object.amount)
                : long_1.default.ZERO;
        message.decimals = (_b = object.decimals) !== null && _b !== void 0 ? _b : 0;
        return message;
    },
};
exports.AddressServiceService = {
    getAddresses: {
        path: "/wavesenterprise.AddressService/GetAddresses",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(empty_1.Empty.encode(value).finish()),
        requestDeserialize: (value) => empty_1.Empty.decode(value),
        responseSerialize: (value) => Buffer.from(exports.AddressesResponse.encode(value).finish()),
        responseDeserialize: (value) => exports.AddressesResponse.decode(value),
    },
    getAddressData: {
        path: "/wavesenterprise.AddressService/GetAddressData",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(exports.AddressDataRequest.encode(value).finish()),
        requestDeserialize: (value) => exports.AddressDataRequest.decode(value),
        responseSerialize: (value) => Buffer.from(exports.AddressDataResponse.encode(value).finish()),
        responseDeserialize: (value) => exports.AddressDataResponse.decode(value),
    },
    getAssetBalance: {
        path: "/wavesenterprise.AddressService/GetAssetBalance",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(exports.AssetBalanceRequest.encode(value).finish()),
        requestDeserialize: (value) => exports.AssetBalanceRequest.decode(value),
        responseSerialize: (value) => Buffer.from(exports.AssetBalanceResponse.encode(value).finish()),
        responseDeserialize: (value) => exports.AssetBalanceResponse.decode(value),
    },
};
exports.AddressServiceClient = (0, grpc_js_1.makeGenericClientConstructor)(exports.AddressServiceService, "wavesenterprise.AddressService");
var globalThis = (() => {
    if (typeof globalThis !== "undefined")
        return globalThis;
    if (typeof self !== "undefined")
        return self;
    if (typeof window !== "undefined")
        return window;
    if (typeof global !== "undefined")
        return global;
    throw "Unable to locate global object";
})();
const atob = globalThis.atob ||
    ((b64) => globalThis.Buffer.from(b64, "base64").toString("binary"));
function bytesFromBase64(b64) {
    const bin = atob(b64);
    const arr = new Uint8Array(bin.length);
    for (let i = 0; i < bin.length; ++i) {
        arr[i] = bin.charCodeAt(i);
    }
    return arr;
}
const btoa = globalThis.btoa ||
    ((bin) => globalThis.Buffer.from(bin, "binary").toString("base64"));
function base64FromBytes(arr) {
    const bin = [];
    for (const byte of arr) {
        bin.push(String.fromCharCode(byte));
    }
    return btoa(bin.join(""));
}
if (_m0.util.Long !== long_1.default) {
    _m0.util.Long = long_1.default;
    _m0.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
//# sourceMappingURL=contract_address_service.js.map