"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ContractServiceClient = exports.ContractServiceService = exports.AssetId = exports.ContractKeyResponse = exports.ContractKeyRequest = exports.ContractKeysResponse = exports.KeysFilter = exports.ContractKeysRequest = exports.CommitExecutionResponse = exports.ExecutionErrorRequest = exports.ExecutionSuccessRequest = exports.CallContractTransactionData = exports.CreateContractTransactionData = exports.ContractTransaction = exports.ContractTransactionResponse = exports.ConnectionRequest = exports.ContractBalanceResponse = exports.ContractBalancesResponse = exports.ContractBalancesRequest = exports.CalculateAssetIdRequest = exports.protobufPackage = void 0;
const long_1 = __importDefault(require("long"));
const grpc_js_1 = require("@grpc/grpc-js");
const _m0 = __importStar(require("protobufjs/minimal"));
const data_entry_1 = require("../data_entry");
const contract_transfer_in_1 = require("../contract_transfer_in");
const contract_asset_operation_1 = require("../contract_asset_operation");
const wrappers_1 = require("../google/protobuf/wrappers");
exports.protobufPackage = "wavesenterprise";
function createBaseCalculateAssetIdRequest() {
    return { nonce: 0 };
}
exports.CalculateAssetIdRequest = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.nonce !== undefined && message.nonce !== 0) {
            writer.uint32(8).int32(message.nonce);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseCalculateAssetIdRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.nonce = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            nonce: isSet(object.nonce) ? Number(object.nonce) : 0,
        };
    },
    toJSON(message) {
        const obj = {};
        message.nonce !== undefined && (obj.nonce = Math.round(message.nonce));
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseCalculateAssetIdRequest();
        message.nonce = (_a = object.nonce) !== null && _a !== void 0 ? _a : 0;
        return message;
    },
};
function createBaseContractBalancesRequest() {
    return { assetsIds: [] };
}
exports.ContractBalancesRequest = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.assetsIds !== undefined && message.assetsIds.length !== 0) {
            for (const v of message.assetsIds) {
                wrappers_1.StringValue.encode({ value: v }, writer.uint32(10).fork()).ldelim();
            }
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseContractBalancesRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.assetsIds.push(wrappers_1.StringValue.decode(reader, reader.uint32()).value);
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            assetsIds: Array.isArray(object === null || object === void 0 ? void 0 : object.assetsIds)
                ? object.assetsIds.map((e) => String(e))
                : [],
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.assetsIds) {
            obj.assetsIds = message.assetsIds.map((e) => e);
        }
        else {
            obj.assetsIds = [];
        }
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseContractBalancesRequest();
        message.assetsIds = ((_a = object.assetsIds) === null || _a === void 0 ? void 0 : _a.map((e) => e)) || [];
        return message;
    },
};
function createBaseContractBalancesResponse() {
    return { assetsBalances: [] };
}
exports.ContractBalancesResponse = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.assetsBalances !== undefined &&
            message.assetsBalances.length !== 0) {
            for (const v of message.assetsBalances) {
                exports.ContractBalanceResponse.encode(v, writer.uint32(10).fork()).ldelim();
            }
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseContractBalancesResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.assetsBalances.push(exports.ContractBalanceResponse.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            assetsBalances: Array.isArray(object === null || object === void 0 ? void 0 : object.assetsBalances)
                ? object.assetsBalances.map((e) => exports.ContractBalanceResponse.fromJSON(e))
                : [],
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.assetsBalances) {
            obj.assetsBalances = message.assetsBalances.map((e) => e ? exports.ContractBalanceResponse.toJSON(e) : undefined);
        }
        else {
            obj.assetsBalances = [];
        }
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseContractBalancesResponse();
        message.assetsBalances =
            ((_a = object.assetsBalances) === null || _a === void 0 ? void 0 : _a.map((e) => exports.ContractBalanceResponse.fromPartial(e))) || [];
        return message;
    },
};
function createBaseContractBalanceResponse() {
    return { assetId: undefined, amount: long_1.default.ZERO, decimals: 0 };
}
exports.ContractBalanceResponse = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.assetId !== undefined) {
            wrappers_1.StringValue.encode({ value: message.assetId }, writer.uint32(10).fork()).ldelim();
        }
        if (message.amount !== undefined && !message.amount.isZero()) {
            writer.uint32(16).int64(message.amount);
        }
        if (message.decimals !== undefined && message.decimals !== 0) {
            writer.uint32(24).int32(message.decimals);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseContractBalanceResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.assetId = wrappers_1.StringValue.decode(reader, reader.uint32()).value;
                    break;
                case 2:
                    message.amount = reader.int64();
                    break;
                case 3:
                    message.decimals = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            assetId: isSet(object.assetId) ? String(object.assetId) : undefined,
            amount: isSet(object.amount) ? long_1.default.fromString(object.amount) : long_1.default.ZERO,
            decimals: isSet(object.decimals) ? Number(object.decimals) : 0,
        };
    },
    toJSON(message) {
        const obj = {};
        message.assetId !== undefined && (obj.assetId = message.assetId);
        message.amount !== undefined &&
            (obj.amount = (message.amount || long_1.default.ZERO).toString());
        message.decimals !== undefined &&
            (obj.decimals = Math.round(message.decimals));
        return obj;
    },
    fromPartial(object) {
        var _a, _b;
        const message = createBaseContractBalanceResponse();
        message.assetId = (_a = object.assetId) !== null && _a !== void 0 ? _a : undefined;
        message.amount =
            object.amount !== undefined && object.amount !== null
                ? long_1.default.fromValue(object.amount)
                : long_1.default.ZERO;
        message.decimals = (_b = object.decimals) !== null && _b !== void 0 ? _b : 0;
        return message;
    },
};
function createBaseConnectionRequest() {
    return { connectionId: "" };
}
exports.ConnectionRequest = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.connectionId !== undefined && message.connectionId !== "") {
            writer.uint32(10).string(message.connectionId);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseConnectionRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.connectionId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            connectionId: isSet(object.connectionId)
                ? String(object.connectionId)
                : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.connectionId !== undefined &&
            (obj.connectionId = message.connectionId);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseConnectionRequest();
        message.connectionId = (_a = object.connectionId) !== null && _a !== void 0 ? _a : "";
        return message;
    },
};
function createBaseContractTransactionResponse() {
    return { transaction: undefined, authToken: "" };
}
exports.ContractTransactionResponse = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.transaction !== undefined) {
            exports.ContractTransaction.encode(message.transaction, writer.uint32(10).fork()).ldelim();
        }
        if (message.authToken !== undefined && message.authToken !== "") {
            writer.uint32(18).string(message.authToken);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseContractTransactionResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.transaction = exports.ContractTransaction.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.authToken = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            transaction: isSet(object.transaction)
                ? exports.ContractTransaction.fromJSON(object.transaction)
                : undefined,
            authToken: isSet(object.authToken) ? String(object.authToken) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.transaction !== undefined &&
            (obj.transaction = message.transaction
                ? exports.ContractTransaction.toJSON(message.transaction)
                : undefined);
        message.authToken !== undefined && (obj.authToken = message.authToken);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseContractTransactionResponse();
        message.transaction =
            object.transaction !== undefined && object.transaction !== null
                ? exports.ContractTransaction.fromPartial(object.transaction)
                : undefined;
        message.authToken = (_a = object.authToken) !== null && _a !== void 0 ? _a : "";
        return message;
    },
};
function createBaseContractTransaction() {
    return {
        id: "",
        type: 0,
        sender: "",
        senderPublicKey: "",
        contractId: "",
        params: [],
        fee: long_1.default.ZERO,
        version: 0,
        proofs: new Uint8Array(),
        timestamp: long_1.default.ZERO,
        feeAssetId: undefined,
        payments: [],
        createData: undefined,
        callData: undefined,
    };
}
exports.ContractTransaction = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.id !== undefined && message.id !== "") {
            writer.uint32(10).string(message.id);
        }
        if (message.type !== undefined && message.type !== 0) {
            writer.uint32(16).int32(message.type);
        }
        if (message.sender !== undefined && message.sender !== "") {
            writer.uint32(26).string(message.sender);
        }
        if (message.senderPublicKey !== undefined &&
            message.senderPublicKey !== "") {
            writer.uint32(34).string(message.senderPublicKey);
        }
        if (message.contractId !== undefined && message.contractId !== "") {
            writer.uint32(42).string(message.contractId);
        }
        if (message.params !== undefined && message.params.length !== 0) {
            for (const v of message.params) {
                data_entry_1.DataEntry.encode(v, writer.uint32(50).fork()).ldelim();
            }
        }
        if (message.fee !== undefined && !message.fee.isZero()) {
            writer.uint32(56).int64(message.fee);
        }
        if (message.version !== undefined && message.version !== 0) {
            writer.uint32(64).int32(message.version);
        }
        if (message.proofs !== undefined && message.proofs.length !== 0) {
            writer.uint32(74).bytes(message.proofs);
        }
        if (message.timestamp !== undefined && !message.timestamp.isZero()) {
            writer.uint32(80).int64(message.timestamp);
        }
        if (message.feeAssetId !== undefined) {
            exports.AssetId.encode(message.feeAssetId, writer.uint32(90).fork()).ldelim();
        }
        if (message.payments !== undefined && message.payments.length !== 0) {
            for (const v of message.payments) {
                contract_transfer_in_1.ContractTransferIn.encode(v, writer.uint32(98).fork()).ldelim();
            }
        }
        if (message.createData !== undefined) {
            exports.CreateContractTransactionData.encode(message.createData, writer.uint32(162).fork()).ldelim();
        }
        if (message.callData !== undefined) {
            exports.CallContractTransactionData.encode(message.callData, writer.uint32(170).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseContractTransaction();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.id = reader.string();
                    break;
                case 2:
                    message.type = reader.int32();
                    break;
                case 3:
                    message.sender = reader.string();
                    break;
                case 4:
                    message.senderPublicKey = reader.string();
                    break;
                case 5:
                    message.contractId = reader.string();
                    break;
                case 6:
                    message.params.push(data_entry_1.DataEntry.decode(reader, reader.uint32()));
                    break;
                case 7:
                    message.fee = reader.int64();
                    break;
                case 8:
                    message.version = reader.int32();
                    break;
                case 9:
                    message.proofs = reader.bytes();
                    break;
                case 10:
                    message.timestamp = reader.int64();
                    break;
                case 11:
                    message.feeAssetId = exports.AssetId.decode(reader, reader.uint32());
                    break;
                case 12:
                    message.payments.push(contract_transfer_in_1.ContractTransferIn.decode(reader, reader.uint32()));
                    break;
                case 20:
                    message.createData = exports.CreateContractTransactionData.decode(reader, reader.uint32());
                    break;
                case 21:
                    message.callData = exports.CallContractTransactionData.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            id: isSet(object.id) ? String(object.id) : "",
            type: isSet(object.type) ? Number(object.type) : 0,
            sender: isSet(object.sender) ? String(object.sender) : "",
            senderPublicKey: isSet(object.senderPublicKey)
                ? String(object.senderPublicKey)
                : "",
            contractId: isSet(object.contractId) ? String(object.contractId) : "",
            params: Array.isArray(object === null || object === void 0 ? void 0 : object.params)
                ? object.params.map((e) => data_entry_1.DataEntry.fromJSON(e))
                : [],
            fee: isSet(object.fee) ? long_1.default.fromString(object.fee) : long_1.default.ZERO,
            version: isSet(object.version) ? Number(object.version) : 0,
            proofs: isSet(object.proofs)
                ? bytesFromBase64(object.proofs)
                : new Uint8Array(),
            timestamp: isSet(object.timestamp)
                ? long_1.default.fromString(object.timestamp)
                : long_1.default.ZERO,
            feeAssetId: isSet(object.feeAssetId)
                ? exports.AssetId.fromJSON(object.feeAssetId)
                : undefined,
            payments: Array.isArray(object === null || object === void 0 ? void 0 : object.payments)
                ? object.payments.map((e) => contract_transfer_in_1.ContractTransferIn.fromJSON(e))
                : [],
            createData: isSet(object.createData)
                ? exports.CreateContractTransactionData.fromJSON(object.createData)
                : undefined,
            callData: isSet(object.callData)
                ? exports.CallContractTransactionData.fromJSON(object.callData)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.id !== undefined && (obj.id = message.id);
        message.type !== undefined && (obj.type = Math.round(message.type));
        message.sender !== undefined && (obj.sender = message.sender);
        message.senderPublicKey !== undefined &&
            (obj.senderPublicKey = message.senderPublicKey);
        message.contractId !== undefined && (obj.contractId = message.contractId);
        if (message.params) {
            obj.params = message.params.map((e) => e ? data_entry_1.DataEntry.toJSON(e) : undefined);
        }
        else {
            obj.params = [];
        }
        message.fee !== undefined &&
            (obj.fee = (message.fee || long_1.default.ZERO).toString());
        message.version !== undefined &&
            (obj.version = Math.round(message.version));
        message.proofs !== undefined &&
            (obj.proofs = base64FromBytes(message.proofs !== undefined ? message.proofs : new Uint8Array()));
        message.timestamp !== undefined &&
            (obj.timestamp = (message.timestamp || long_1.default.ZERO).toString());
        message.feeAssetId !== undefined &&
            (obj.feeAssetId = message.feeAssetId
                ? exports.AssetId.toJSON(message.feeAssetId)
                : undefined);
        if (message.payments) {
            obj.payments = message.payments.map((e) => e ? contract_transfer_in_1.ContractTransferIn.toJSON(e) : undefined);
        }
        else {
            obj.payments = [];
        }
        message.createData !== undefined &&
            (obj.createData = message.createData
                ? exports.CreateContractTransactionData.toJSON(message.createData)
                : undefined);
        message.callData !== undefined &&
            (obj.callData = message.callData
                ? exports.CallContractTransactionData.toJSON(message.callData)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j;
        const message = createBaseContractTransaction();
        message.id = (_a = object.id) !== null && _a !== void 0 ? _a : "";
        message.type = (_b = object.type) !== null && _b !== void 0 ? _b : 0;
        message.sender = (_c = object.sender) !== null && _c !== void 0 ? _c : "";
        message.senderPublicKey = (_d = object.senderPublicKey) !== null && _d !== void 0 ? _d : "";
        message.contractId = (_e = object.contractId) !== null && _e !== void 0 ? _e : "";
        message.params = ((_f = object.params) === null || _f === void 0 ? void 0 : _f.map((e) => data_entry_1.DataEntry.fromPartial(e))) || [];
        message.fee =
            object.fee !== undefined && object.fee !== null
                ? long_1.default.fromValue(object.fee)
                : long_1.default.ZERO;
        message.version = (_g = object.version) !== null && _g !== void 0 ? _g : 0;
        message.proofs = (_h = object.proofs) !== null && _h !== void 0 ? _h : new Uint8Array();
        message.timestamp =
            object.timestamp !== undefined && object.timestamp !== null
                ? long_1.default.fromValue(object.timestamp)
                : long_1.default.ZERO;
        message.feeAssetId =
            object.feeAssetId !== undefined && object.feeAssetId !== null
                ? exports.AssetId.fromPartial(object.feeAssetId)
                : undefined;
        message.payments =
            ((_j = object.payments) === null || _j === void 0 ? void 0 : _j.map((e) => contract_transfer_in_1.ContractTransferIn.fromPartial(e))) || [];
        message.createData =
            object.createData !== undefined && object.createData !== null
                ? exports.CreateContractTransactionData.fromPartial(object.createData)
                : undefined;
        message.callData =
            object.callData !== undefined && object.callData !== null
                ? exports.CallContractTransactionData.fromPartial(object.callData)
                : undefined;
        return message;
    },
};
function createBaseCreateContractTransactionData() {
    return { image: "", imageHash: "", contractName: "" };
}
exports.CreateContractTransactionData = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.image !== undefined && message.image !== "") {
            writer.uint32(10).string(message.image);
        }
        if (message.imageHash !== undefined && message.imageHash !== "") {
            writer.uint32(18).string(message.imageHash);
        }
        if (message.contractName !== undefined && message.contractName !== "") {
            writer.uint32(26).string(message.contractName);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseCreateContractTransactionData();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.image = reader.string();
                    break;
                case 2:
                    message.imageHash = reader.string();
                    break;
                case 3:
                    message.contractName = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            image: isSet(object.image) ? String(object.image) : "",
            imageHash: isSet(object.imageHash) ? String(object.imageHash) : "",
            contractName: isSet(object.contractName)
                ? String(object.contractName)
                : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.image !== undefined && (obj.image = message.image);
        message.imageHash !== undefined && (obj.imageHash = message.imageHash);
        message.contractName !== undefined &&
            (obj.contractName = message.contractName);
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c;
        const message = createBaseCreateContractTransactionData();
        message.image = (_a = object.image) !== null && _a !== void 0 ? _a : "";
        message.imageHash = (_b = object.imageHash) !== null && _b !== void 0 ? _b : "";
        message.contractName = (_c = object.contractName) !== null && _c !== void 0 ? _c : "";
        return message;
    },
};
function createBaseCallContractTransactionData() {
    return { contractVersion: 0 };
}
exports.CallContractTransactionData = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.contractVersion !== undefined &&
            message.contractVersion !== 0) {
            writer.uint32(8).int32(message.contractVersion);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseCallContractTransactionData();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.contractVersion = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            contractVersion: isSet(object.contractVersion)
                ? Number(object.contractVersion)
                : 0,
        };
    },
    toJSON(message) {
        const obj = {};
        message.contractVersion !== undefined &&
            (obj.contractVersion = Math.round(message.contractVersion));
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseCallContractTransactionData();
        message.contractVersion = (_a = object.contractVersion) !== null && _a !== void 0 ? _a : 0;
        return message;
    },
};
function createBaseExecutionSuccessRequest() {
    return { txId: "", results: [], assetOperations: [] };
}
exports.ExecutionSuccessRequest = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.txId !== undefined && message.txId !== "") {
            writer.uint32(10).string(message.txId);
        }
        if (message.results !== undefined && message.results.length !== 0) {
            for (const v of message.results) {
                data_entry_1.DataEntry.encode(v, writer.uint32(18).fork()).ldelim();
            }
        }
        if (message.assetOperations !== undefined &&
            message.assetOperations.length !== 0) {
            for (const v of message.assetOperations) {
                contract_asset_operation_1.ContractAssetOperation.encode(v, writer.uint32(26).fork()).ldelim();
            }
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseExecutionSuccessRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.txId = reader.string();
                    break;
                case 2:
                    message.results.push(data_entry_1.DataEntry.decode(reader, reader.uint32()));
                    break;
                case 3:
                    message.assetOperations.push(contract_asset_operation_1.ContractAssetOperation.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            txId: isSet(object.txId) ? String(object.txId) : "",
            results: Array.isArray(object === null || object === void 0 ? void 0 : object.results)
                ? object.results.map((e) => data_entry_1.DataEntry.fromJSON(e))
                : [],
            assetOperations: Array.isArray(object === null || object === void 0 ? void 0 : object.assetOperations)
                ? object.assetOperations.map((e) => contract_asset_operation_1.ContractAssetOperation.fromJSON(e))
                : [],
        };
    },
    toJSON(message) {
        const obj = {};
        message.txId !== undefined && (obj.txId = message.txId);
        if (message.results) {
            obj.results = message.results.map((e) => e ? data_entry_1.DataEntry.toJSON(e) : undefined);
        }
        else {
            obj.results = [];
        }
        if (message.assetOperations) {
            obj.assetOperations = message.assetOperations.map((e) => e ? contract_asset_operation_1.ContractAssetOperation.toJSON(e) : undefined);
        }
        else {
            obj.assetOperations = [];
        }
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c;
        const message = createBaseExecutionSuccessRequest();
        message.txId = (_a = object.txId) !== null && _a !== void 0 ? _a : "";
        message.results =
            ((_b = object.results) === null || _b === void 0 ? void 0 : _b.map((e) => data_entry_1.DataEntry.fromPartial(e))) || [];
        message.assetOperations =
            ((_c = object.assetOperations) === null || _c === void 0 ? void 0 : _c.map((e) => contract_asset_operation_1.ContractAssetOperation.fromPartial(e))) || [];
        return message;
    },
};
function createBaseExecutionErrorRequest() {
    return { txId: "", message: "", code: 0 };
}
exports.ExecutionErrorRequest = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.txId !== undefined && message.txId !== "") {
            writer.uint32(10).string(message.txId);
        }
        if (message.message !== undefined && message.message !== "") {
            writer.uint32(18).string(message.message);
        }
        if (message.code !== undefined && message.code !== 0) {
            writer.uint32(24).int32(message.code);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseExecutionErrorRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.txId = reader.string();
                    break;
                case 2:
                    message.message = reader.string();
                    break;
                case 3:
                    message.code = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            txId: isSet(object.txId) ? String(object.txId) : "",
            message: isSet(object.message) ? String(object.message) : "",
            code: isSet(object.code) ? Number(object.code) : 0,
        };
    },
    toJSON(message) {
        const obj = {};
        message.txId !== undefined && (obj.txId = message.txId);
        message.message !== undefined && (obj.message = message.message);
        message.code !== undefined && (obj.code = Math.round(message.code));
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c;
        const message = createBaseExecutionErrorRequest();
        message.txId = (_a = object.txId) !== null && _a !== void 0 ? _a : "";
        message.message = (_b = object.message) !== null && _b !== void 0 ? _b : "";
        message.code = (_c = object.code) !== null && _c !== void 0 ? _c : 0;
        return message;
    },
};
function createBaseCommitExecutionResponse() {
    return {};
}
exports.CommitExecutionResponse = {
    encode(_, writer = _m0.Writer.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseCommitExecutionResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        return {};
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseCommitExecutionResponse();
        return message;
    },
};
function createBaseContractKeysRequest() {
    return {
        contractId: "",
        limit: undefined,
        offset: undefined,
        matches: undefined,
        keysFilter: undefined,
    };
}
exports.ContractKeysRequest = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.contractId !== undefined && message.contractId !== "") {
            writer.uint32(10).string(message.contractId);
        }
        if (message.limit !== undefined) {
            wrappers_1.Int32Value.encode({ value: message.limit }, writer.uint32(18).fork()).ldelim();
        }
        if (message.offset !== undefined) {
            wrappers_1.Int32Value.encode({ value: message.offset }, writer.uint32(26).fork()).ldelim();
        }
        if (message.matches !== undefined) {
            wrappers_1.StringValue.encode({ value: message.matches }, writer.uint32(34).fork()).ldelim();
        }
        if (message.keysFilter !== undefined) {
            exports.KeysFilter.encode(message.keysFilter, writer.uint32(42).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseContractKeysRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.contractId = reader.string();
                    break;
                case 2:
                    message.limit = wrappers_1.Int32Value.decode(reader, reader.uint32()).value;
                    break;
                case 3:
                    message.offset = wrappers_1.Int32Value.decode(reader, reader.uint32()).value;
                    break;
                case 4:
                    message.matches = wrappers_1.StringValue.decode(reader, reader.uint32()).value;
                    break;
                case 5:
                    message.keysFilter = exports.KeysFilter.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            contractId: isSet(object.contractId) ? String(object.contractId) : "",
            limit: isSet(object.limit) ? Number(object.limit) : undefined,
            offset: isSet(object.offset) ? Number(object.offset) : undefined,
            matches: isSet(object.matches) ? String(object.matches) : undefined,
            keysFilter: isSet(object.keysFilter)
                ? exports.KeysFilter.fromJSON(object.keysFilter)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.contractId !== undefined && (obj.contractId = message.contractId);
        message.limit !== undefined && (obj.limit = message.limit);
        message.offset !== undefined && (obj.offset = message.offset);
        message.matches !== undefined && (obj.matches = message.matches);
        message.keysFilter !== undefined &&
            (obj.keysFilter = message.keysFilter
                ? exports.KeysFilter.toJSON(message.keysFilter)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c, _d;
        const message = createBaseContractKeysRequest();
        message.contractId = (_a = object.contractId) !== null && _a !== void 0 ? _a : "";
        message.limit = (_b = object.limit) !== null && _b !== void 0 ? _b : undefined;
        message.offset = (_c = object.offset) !== null && _c !== void 0 ? _c : undefined;
        message.matches = (_d = object.matches) !== null && _d !== void 0 ? _d : undefined;
        message.keysFilter =
            object.keysFilter !== undefined && object.keysFilter !== null
                ? exports.KeysFilter.fromPartial(object.keysFilter)
                : undefined;
        return message;
    },
};
function createBaseKeysFilter() {
    return { keys: [] };
}
exports.KeysFilter = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.keys !== undefined && message.keys.length !== 0) {
            for (const v of message.keys) {
                writer.uint32(10).string(v);
            }
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseKeysFilter();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.keys.push(reader.string());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            keys: Array.isArray(object === null || object === void 0 ? void 0 : object.keys)
                ? object.keys.map((e) => String(e))
                : [],
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.keys) {
            obj.keys = message.keys.map((e) => e);
        }
        else {
            obj.keys = [];
        }
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseKeysFilter();
        message.keys = ((_a = object.keys) === null || _a === void 0 ? void 0 : _a.map((e) => e)) || [];
        return message;
    },
};
function createBaseContractKeysResponse() {
    return { entries: [] };
}
exports.ContractKeysResponse = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.entries !== undefined && message.entries.length !== 0) {
            for (const v of message.entries) {
                data_entry_1.DataEntry.encode(v, writer.uint32(10).fork()).ldelim();
            }
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseContractKeysResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.entries.push(data_entry_1.DataEntry.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            entries: Array.isArray(object === null || object === void 0 ? void 0 : object.entries)
                ? object.entries.map((e) => data_entry_1.DataEntry.fromJSON(e))
                : [],
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.entries) {
            obj.entries = message.entries.map((e) => e ? data_entry_1.DataEntry.toJSON(e) : undefined);
        }
        else {
            obj.entries = [];
        }
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseContractKeysResponse();
        message.entries =
            ((_a = object.entries) === null || _a === void 0 ? void 0 : _a.map((e) => data_entry_1.DataEntry.fromPartial(e))) || [];
        return message;
    },
};
function createBaseContractKeyRequest() {
    return { contractId: "", key: "" };
}
exports.ContractKeyRequest = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.contractId !== undefined && message.contractId !== "") {
            writer.uint32(10).string(message.contractId);
        }
        if (message.key !== undefined && message.key !== "") {
            writer.uint32(18).string(message.key);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseContractKeyRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.contractId = reader.string();
                    break;
                case 2:
                    message.key = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            contractId: isSet(object.contractId) ? String(object.contractId) : "",
            key: isSet(object.key) ? String(object.key) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.contractId !== undefined && (obj.contractId = message.contractId);
        message.key !== undefined && (obj.key = message.key);
        return obj;
    },
    fromPartial(object) {
        var _a, _b;
        const message = createBaseContractKeyRequest();
        message.contractId = (_a = object.contractId) !== null && _a !== void 0 ? _a : "";
        message.key = (_b = object.key) !== null && _b !== void 0 ? _b : "";
        return message;
    },
};
function createBaseContractKeyResponse() {
    return { entry: undefined };
}
exports.ContractKeyResponse = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.entry !== undefined) {
            data_entry_1.DataEntry.encode(message.entry, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseContractKeyResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.entry = data_entry_1.DataEntry.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            entry: isSet(object.entry) ? data_entry_1.DataEntry.fromJSON(object.entry) : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.entry !== undefined &&
            (obj.entry = message.entry ? data_entry_1.DataEntry.toJSON(message.entry) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseContractKeyResponse();
        message.entry =
            object.entry !== undefined && object.entry !== null
                ? data_entry_1.DataEntry.fromPartial(object.entry)
                : undefined;
        return message;
    },
};
function createBaseAssetId() {
    return { value: "" };
}
exports.AssetId = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.value !== undefined && message.value !== "") {
            writer.uint32(10).string(message.value);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseAssetId();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.value = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            value: isSet(object.value) ? String(object.value) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.value !== undefined && (obj.value = message.value);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseAssetId();
        message.value = (_a = object.value) !== null && _a !== void 0 ? _a : "";
        return message;
    },
};
exports.ContractServiceService = {
    connect: {
        path: "/wavesenterprise.ContractService/Connect",
        requestStream: false,
        responseStream: true,
        requestSerialize: (value) => Buffer.from(exports.ConnectionRequest.encode(value).finish()),
        requestDeserialize: (value) => exports.ConnectionRequest.decode(value),
        responseSerialize: (value) => Buffer.from(exports.ContractTransactionResponse.encode(value).finish()),
        responseDeserialize: (value) => exports.ContractTransactionResponse.decode(value),
    },
    commitExecutionSuccess: {
        path: "/wavesenterprise.ContractService/CommitExecutionSuccess",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(exports.ExecutionSuccessRequest.encode(value).finish()),
        requestDeserialize: (value) => exports.ExecutionSuccessRequest.decode(value),
        responseSerialize: (value) => Buffer.from(exports.CommitExecutionResponse.encode(value).finish()),
        responseDeserialize: (value) => exports.CommitExecutionResponse.decode(value),
    },
    commitExecutionError: {
        path: "/wavesenterprise.ContractService/CommitExecutionError",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(exports.ExecutionErrorRequest.encode(value).finish()),
        requestDeserialize: (value) => exports.ExecutionErrorRequest.decode(value),
        responseSerialize: (value) => Buffer.from(exports.CommitExecutionResponse.encode(value).finish()),
        responseDeserialize: (value) => exports.CommitExecutionResponse.decode(value),
    },
    getContractKeys: {
        path: "/wavesenterprise.ContractService/GetContractKeys",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(exports.ContractKeysRequest.encode(value).finish()),
        requestDeserialize: (value) => exports.ContractKeysRequest.decode(value),
        responseSerialize: (value) => Buffer.from(exports.ContractKeysResponse.encode(value).finish()),
        responseDeserialize: (value) => exports.ContractKeysResponse.decode(value),
    },
    getContractKey: {
        path: "/wavesenterprise.ContractService/GetContractKey",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(exports.ContractKeyRequest.encode(value).finish()),
        requestDeserialize: (value) => exports.ContractKeyRequest.decode(value),
        responseSerialize: (value) => Buffer.from(exports.ContractKeyResponse.encode(value).finish()),
        responseDeserialize: (value) => exports.ContractKeyResponse.decode(value),
    },
    getContractBalances: {
        path: "/wavesenterprise.ContractService/GetContractBalances",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(exports.ContractBalancesRequest.encode(value).finish()),
        requestDeserialize: (value) => exports.ContractBalancesRequest.decode(value),
        responseSerialize: (value) => Buffer.from(exports.ContractBalancesResponse.encode(value).finish()),
        responseDeserialize: (value) => exports.ContractBalancesResponse.decode(value),
    },
    calculateAssetId: {
        path: "/wavesenterprise.ContractService/CalculateAssetId",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(exports.CalculateAssetIdRequest.encode(value).finish()),
        requestDeserialize: (value) => exports.CalculateAssetIdRequest.decode(value),
        responseSerialize: (value) => Buffer.from(exports.AssetId.encode(value).finish()),
        responseDeserialize: (value) => exports.AssetId.decode(value),
    },
};
exports.ContractServiceClient = (0, grpc_js_1.makeGenericClientConstructor)(exports.ContractServiceService, "wavesenterprise.ContractService");
var globalThis = (() => {
    if (typeof globalThis !== "undefined")
        return globalThis;
    if (typeof self !== "undefined")
        return self;
    if (typeof window !== "undefined")
        return window;
    if (typeof global !== "undefined")
        return global;
    throw "Unable to locate global object";
})();
const atob = globalThis.atob ||
    ((b64) => globalThis.Buffer.from(b64, "base64").toString("binary"));
function bytesFromBase64(b64) {
    const bin = atob(b64);
    const arr = new Uint8Array(bin.length);
    for (let i = 0; i < bin.length; ++i) {
        arr[i] = bin.charCodeAt(i);
    }
    return arr;
}
const btoa = globalThis.btoa ||
    ((bin) => globalThis.Buffer.from(bin, "binary").toString("base64"));
function base64FromBytes(arr) {
    const bin = [];
    for (const byte of arr) {
        bin.push(String.fromCharCode(byte));
    }
    return btoa(bin.join(""));
}
if (_m0.util.Long !== long_1.default) {
    _m0.util.Long = long_1.default;
    _m0.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
//# sourceMappingURL=contract_contract_service.js.map