import Long from "long";
import { ChannelCredentials, ChannelOptions, UntypedServiceImplementation, handleUnaryCall, Client, ClientUnaryCall, Metadata, CallOptions, ServiceError } from "@grpc/grpc-js";
import * as _m0 from "protobufjs/minimal";
export declare const protobufPackage = "wavesenterprise";
export interface PermissionsRequest {
    address?: string;
    timestamp?: Long;
}
export interface PermissionsResponse {
    roles?: RoleInfo[];
    timestamp?: Long;
}
export interface RoleInfo {
    role?: string;
    dueTimestamp?: Long;
}
export interface AddressesPermissionsRequest {
    addresses?: string[];
    timestamp?: Long;
}
export interface AddressesPermissionsResponse {
    addressToRoles?: RolesForAddressResponse[];
    timestamp?: Long;
}
export interface RolesForAddressResponse {
    address?: string;
    roles?: RoleInfo[];
}
export declare const PermissionsRequest: {
    encode(message: PermissionsRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): PermissionsRequest;
    fromJSON(object: any): PermissionsRequest;
    toJSON(message: PermissionsRequest): unknown;
    fromPartial(object: DeepPartial<PermissionsRequest>): PermissionsRequest;
};
export declare const PermissionsResponse: {
    encode(message: PermissionsResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): PermissionsResponse;
    fromJSON(object: any): PermissionsResponse;
    toJSON(message: PermissionsResponse): unknown;
    fromPartial(object: DeepPartial<PermissionsResponse>): PermissionsResponse;
};
export declare const RoleInfo: {
    encode(message: RoleInfo, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): RoleInfo;
    fromJSON(object: any): RoleInfo;
    toJSON(message: RoleInfo): unknown;
    fromPartial(object: DeepPartial<RoleInfo>): RoleInfo;
};
export declare const AddressesPermissionsRequest: {
    encode(message: AddressesPermissionsRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): AddressesPermissionsRequest;
    fromJSON(object: any): AddressesPermissionsRequest;
    toJSON(message: AddressesPermissionsRequest): unknown;
    fromPartial(object: DeepPartial<AddressesPermissionsRequest>): AddressesPermissionsRequest;
};
export declare const AddressesPermissionsResponse: {
    encode(message: AddressesPermissionsResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): AddressesPermissionsResponse;
    fromJSON(object: any): AddressesPermissionsResponse;
    toJSON(message: AddressesPermissionsResponse): unknown;
    fromPartial(object: DeepPartial<AddressesPermissionsResponse>): AddressesPermissionsResponse;
};
export declare const RolesForAddressResponse: {
    encode(message: RolesForAddressResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): RolesForAddressResponse;
    fromJSON(object: any): RolesForAddressResponse;
    toJSON(message: RolesForAddressResponse): unknown;
    fromPartial(object: DeepPartial<RolesForAddressResponse>): RolesForAddressResponse;
};
export declare const PermissionServiceService: {
    readonly getPermissions: {
        readonly path: "/wavesenterprise.PermissionService/GetPermissions";
        readonly requestStream: false;
        readonly responseStream: false;
        readonly requestSerialize: (value: PermissionsRequest) => Buffer;
        readonly requestDeserialize: (value: Buffer) => PermissionsRequest;
        readonly responseSerialize: (value: PermissionsResponse) => Buffer;
        readonly responseDeserialize: (value: Buffer) => PermissionsResponse;
    };
    readonly getPermissionsForAddresses: {
        readonly path: "/wavesenterprise.PermissionService/GetPermissionsForAddresses";
        readonly requestStream: false;
        readonly responseStream: false;
        readonly requestSerialize: (value: AddressesPermissionsRequest) => Buffer;
        readonly requestDeserialize: (value: Buffer) => AddressesPermissionsRequest;
        readonly responseSerialize: (value: AddressesPermissionsResponse) => Buffer;
        readonly responseDeserialize: (value: Buffer) => AddressesPermissionsResponse;
    };
};
export interface PermissionServiceServer extends UntypedServiceImplementation {
    getPermissions: handleUnaryCall<PermissionsRequest, PermissionsResponse>;
    getPermissionsForAddresses: handleUnaryCall<AddressesPermissionsRequest, AddressesPermissionsResponse>;
}
export interface PermissionServiceClient extends Client {
    getPermissions(request: PermissionsRequest, callback: (error: ServiceError | null, response: PermissionsResponse) => void): ClientUnaryCall;
    getPermissions(request: PermissionsRequest, metadata: Metadata, callback: (error: ServiceError | null, response: PermissionsResponse) => void): ClientUnaryCall;
    getPermissions(request: PermissionsRequest, metadata: Metadata, options: Partial<CallOptions>, callback: (error: ServiceError | null, response: PermissionsResponse) => void): ClientUnaryCall;
    getPermissionsForAddresses(request: AddressesPermissionsRequest, callback: (error: ServiceError | null, response: AddressesPermissionsResponse) => void): ClientUnaryCall;
    getPermissionsForAddresses(request: AddressesPermissionsRequest, metadata: Metadata, callback: (error: ServiceError | null, response: AddressesPermissionsResponse) => void): ClientUnaryCall;
    getPermissionsForAddresses(request: AddressesPermissionsRequest, metadata: Metadata, options: Partial<CallOptions>, callback: (error: ServiceError | null, response: AddressesPermissionsResponse) => void): ClientUnaryCall;
}
export declare const PermissionServiceClient: {
    new (address: string, credentials: ChannelCredentials, options?: Partial<ChannelOptions>): PermissionServiceClient;
    service: typeof PermissionServiceService;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
