import Long from "long";
import { ChannelCredentials, ChannelOptions, UntypedServiceImplementation, handleUnaryCall, Client, ClientUnaryCall, Metadata, CallOptions, ServiceError } from "@grpc/grpc-js";
import * as _m0 from "protobufjs/minimal";
export declare const protobufPackage = "wavesenterprise";
export declare enum PkiSignatureType {
    UNKNOWN = 0,
    CADES_BES = 1,
    CADES_X_LONG_TYPE_1 = 2,
    CADES_T = 3,
    UNRECOGNIZED = -1
}
export declare function pkiSignatureTypeFromJSON(object: any): PkiSignatureType;
export declare function pkiSignatureTypeToJSON(object: PkiSignatureType): string;
export interface PkiVerifyRequest {
    inputData?: Uint8Array;
    signature?: Uint8Array;
    sigType?: PkiSignatureType;
    extendedKeyUsageList?: string[];
}
export interface PkiVerifyResponse {
    status?: boolean;
}
export declare const PkiVerifyRequest: {
    encode(message: PkiVerifyRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): PkiVerifyRequest;
    fromJSON(object: any): PkiVerifyRequest;
    toJSON(message: PkiVerifyRequest): unknown;
    fromPartial(object: DeepPartial<PkiVerifyRequest>): PkiVerifyRequest;
};
export declare const PkiVerifyResponse: {
    encode(message: PkiVerifyResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): PkiVerifyResponse;
    fromJSON(object: any): PkiVerifyResponse;
    toJSON(message: PkiVerifyResponse): unknown;
    fromPartial(object: DeepPartial<PkiVerifyResponse>): PkiVerifyResponse;
};
export declare const PkiServiceService: {
    readonly verify: {
        readonly path: "/wavesenterprise.PkiService/Verify";
        readonly requestStream: false;
        readonly responseStream: false;
        readonly requestSerialize: (value: PkiVerifyRequest) => Buffer;
        readonly requestDeserialize: (value: Buffer) => PkiVerifyRequest;
        readonly responseSerialize: (value: PkiVerifyResponse) => Buffer;
        readonly responseDeserialize: (value: Buffer) => PkiVerifyResponse;
    };
};
export interface PkiServiceServer extends UntypedServiceImplementation {
    verify: handleUnaryCall<PkiVerifyRequest, PkiVerifyResponse>;
}
export interface PkiServiceClient extends Client {
    verify(request: PkiVerifyRequest, callback: (error: ServiceError | null, response: PkiVerifyResponse) => void): ClientUnaryCall;
    verify(request: PkiVerifyRequest, metadata: Metadata, callback: (error: ServiceError | null, response: PkiVerifyResponse) => void): ClientUnaryCall;
    verify(request: PkiVerifyRequest, metadata: Metadata, options: Partial<CallOptions>, callback: (error: ServiceError | null, response: PkiVerifyResponse) => void): ClientUnaryCall;
}
export declare const PkiServiceClient: {
    new (address: string, credentials: ChannelCredentials, options?: Partial<ChannelOptions>): PkiServiceClient;
    service: typeof PkiServiceService;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
