"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PkiServiceClient = exports.PkiServiceService = exports.PkiVerifyResponse = exports.PkiVerifyRequest = exports.pkiSignatureTypeToJSON = exports.pkiSignatureTypeFromJSON = exports.PkiSignatureType = exports.protobufPackage = void 0;
const long_1 = __importDefault(require("long"));
const grpc_js_1 = require("@grpc/grpc-js");
const _m0 = __importStar(require("protobufjs/minimal"));
exports.protobufPackage = "wavesenterprise";
var PkiSignatureType;
(function (PkiSignatureType) {
    PkiSignatureType[PkiSignatureType["UNKNOWN"] = 0] = "UNKNOWN";
    PkiSignatureType[PkiSignatureType["CADES_BES"] = 1] = "CADES_BES";
    PkiSignatureType[PkiSignatureType["CADES_X_LONG_TYPE_1"] = 2] = "CADES_X_LONG_TYPE_1";
    PkiSignatureType[PkiSignatureType["CADES_T"] = 3] = "CADES_T";
    PkiSignatureType[PkiSignatureType["UNRECOGNIZED"] = -1] = "UNRECOGNIZED";
})(PkiSignatureType = exports.PkiSignatureType || (exports.PkiSignatureType = {}));
function pkiSignatureTypeFromJSON(object) {
    switch (object) {
        case 0:
        case "UNKNOWN":
            return PkiSignatureType.UNKNOWN;
        case 1:
        case "CADES_BES":
            return PkiSignatureType.CADES_BES;
        case 2:
        case "CADES_X_LONG_TYPE_1":
            return PkiSignatureType.CADES_X_LONG_TYPE_1;
        case 3:
        case "CADES_T":
            return PkiSignatureType.CADES_T;
        case -1:
        case "UNRECOGNIZED":
        default:
            return PkiSignatureType.UNRECOGNIZED;
    }
}
exports.pkiSignatureTypeFromJSON = pkiSignatureTypeFromJSON;
function pkiSignatureTypeToJSON(object) {
    switch (object) {
        case PkiSignatureType.UNKNOWN:
            return "UNKNOWN";
        case PkiSignatureType.CADES_BES:
            return "CADES_BES";
        case PkiSignatureType.CADES_X_LONG_TYPE_1:
            return "CADES_X_LONG_TYPE_1";
        case PkiSignatureType.CADES_T:
            return "CADES_T";
        default:
            return "UNKNOWN";
    }
}
exports.pkiSignatureTypeToJSON = pkiSignatureTypeToJSON;
function createBasePkiVerifyRequest() {
    return {
        inputData: new Uint8Array(),
        signature: new Uint8Array(),
        sigType: 0,
        extendedKeyUsageList: [],
    };
}
exports.PkiVerifyRequest = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.inputData !== undefined && message.inputData.length !== 0) {
            writer.uint32(10).bytes(message.inputData);
        }
        if (message.signature !== undefined && message.signature.length !== 0) {
            writer.uint32(18).bytes(message.signature);
        }
        if (message.sigType !== undefined && message.sigType !== 0) {
            writer.uint32(24).int32(message.sigType);
        }
        if (message.extendedKeyUsageList !== undefined &&
            message.extendedKeyUsageList.length !== 0) {
            for (const v of message.extendedKeyUsageList) {
                writer.uint32(34).string(v);
            }
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBasePkiVerifyRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.inputData = reader.bytes();
                    break;
                case 2:
                    message.signature = reader.bytes();
                    break;
                case 3:
                    message.sigType = reader.int32();
                    break;
                case 4:
                    message.extendedKeyUsageList.push(reader.string());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            inputData: isSet(object.inputData)
                ? bytesFromBase64(object.inputData)
                : new Uint8Array(),
            signature: isSet(object.signature)
                ? bytesFromBase64(object.signature)
                : new Uint8Array(),
            sigType: isSet(object.sigType)
                ? pkiSignatureTypeFromJSON(object.sigType)
                : 0,
            extendedKeyUsageList: Array.isArray(object === null || object === void 0 ? void 0 : object.extendedKeyUsageList)
                ? object.extendedKeyUsageList.map((e) => String(e))
                : [],
        };
    },
    toJSON(message) {
        const obj = {};
        message.inputData !== undefined &&
            (obj.inputData = base64FromBytes(message.inputData !== undefined ? message.inputData : new Uint8Array()));
        message.signature !== undefined &&
            (obj.signature = base64FromBytes(message.signature !== undefined ? message.signature : new Uint8Array()));
        message.sigType !== undefined &&
            (obj.sigType = pkiSignatureTypeToJSON(message.sigType));
        if (message.extendedKeyUsageList) {
            obj.extendedKeyUsageList = message.extendedKeyUsageList.map((e) => e);
        }
        else {
            obj.extendedKeyUsageList = [];
        }
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c, _d;
        const message = createBasePkiVerifyRequest();
        message.inputData = (_a = object.inputData) !== null && _a !== void 0 ? _a : new Uint8Array();
        message.signature = (_b = object.signature) !== null && _b !== void 0 ? _b : new Uint8Array();
        message.sigType = (_c = object.sigType) !== null && _c !== void 0 ? _c : 0;
        message.extendedKeyUsageList =
            ((_d = object.extendedKeyUsageList) === null || _d === void 0 ? void 0 : _d.map((e) => e)) || [];
        return message;
    },
};
function createBasePkiVerifyResponse() {
    return { status: false };
}
exports.PkiVerifyResponse = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.status === true) {
            writer.uint32(8).bool(message.status);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBasePkiVerifyResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.status = reader.bool();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            status: isSet(object.status) ? Boolean(object.status) : false,
        };
    },
    toJSON(message) {
        const obj = {};
        message.status !== undefined && (obj.status = message.status);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBasePkiVerifyResponse();
        message.status = (_a = object.status) !== null && _a !== void 0 ? _a : false;
        return message;
    },
};
exports.PkiServiceService = {
    verify: {
        path: "/wavesenterprise.PkiService/Verify",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(exports.PkiVerifyRequest.encode(value).finish()),
        requestDeserialize: (value) => exports.PkiVerifyRequest.decode(value),
        responseSerialize: (value) => Buffer.from(exports.PkiVerifyResponse.encode(value).finish()),
        responseDeserialize: (value) => exports.PkiVerifyResponse.decode(value),
    },
};
exports.PkiServiceClient = (0, grpc_js_1.makeGenericClientConstructor)(exports.PkiServiceService, "wavesenterprise.PkiService");
var globalThis = (() => {
    if (typeof globalThis !== "undefined")
        return globalThis;
    if (typeof self !== "undefined")
        return self;
    if (typeof window !== "undefined")
        return window;
    if (typeof global !== "undefined")
        return global;
    throw "Unable to locate global object";
})();
const atob = globalThis.atob ||
    ((b64) => globalThis.Buffer.from(b64, "base64").toString("binary"));
function bytesFromBase64(b64) {
    const bin = atob(b64);
    const arr = new Uint8Array(bin.length);
    for (let i = 0; i < bin.length; ++i) {
        arr[i] = bin.charCodeAt(i);
    }
    return arr;
}
const btoa = globalThis.btoa ||
    ((bin) => globalThis.Buffer.from(bin, "binary").toString("base64"));
function base64FromBytes(arr) {
    const bin = [];
    for (const byte of arr) {
        bin.push(String.fromCharCode(byte));
    }
    return btoa(bin.join(""));
}
if (_m0.util.Long !== long_1.default) {
    _m0.util.Long = long_1.default;
    _m0.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
//# sourceMappingURL=contract_pki_service.js.map