import Long from "long";
import { ChannelCredentials, ChannelOptions, UntypedServiceImplementation, handleUnaryCall, Client, ClientUnaryCall, Metadata, CallOptions, ServiceError } from "@grpc/grpc-js";
import * as _m0 from "protobufjs/minimal";
export declare const protobufPackage = "wavesenterprise";
export interface PolicyRecipientsRequest {
    policyId?: string;
}
export interface PolicyRecipientsResponse {
    recipients?: string[];
}
export interface PolicyOwnersRequest {
    policyId?: string;
}
export interface PolicyOwnersResponse {
    owners?: string[];
}
export interface PolicyHashesRequest {
    policyId?: string;
}
export interface PolicyHashesResponse {
    hashes?: string[];
}
export interface PolicyItemDataRequest {
    policyId?: string;
    itemHash?: string;
}
export interface PolicyItemDataResponse {
    data?: string;
}
export interface PolicyItemInfoRequest {
    policyId?: string;
    itemHash?: string;
}
export interface PolicyItemInfoResponse {
    sender?: string;
    policyId?: string;
    type?: string;
    info?: PolicyItemFileInfo;
    hash?: string;
}
export interface PolicyItemFileInfo {
    filename?: string;
    size?: number;
    timestamp?: Long;
    author?: string;
    comment?: string;
}
export declare const PolicyRecipientsRequest: {
    encode(message: PolicyRecipientsRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): PolicyRecipientsRequest;
    fromJSON(object: any): PolicyRecipientsRequest;
    toJSON(message: PolicyRecipientsRequest): unknown;
    fromPartial(object: DeepPartial<PolicyRecipientsRequest>): PolicyRecipientsRequest;
};
export declare const PolicyRecipientsResponse: {
    encode(message: PolicyRecipientsResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): PolicyRecipientsResponse;
    fromJSON(object: any): PolicyRecipientsResponse;
    toJSON(message: PolicyRecipientsResponse): unknown;
    fromPartial(object: DeepPartial<PolicyRecipientsResponse>): PolicyRecipientsResponse;
};
export declare const PolicyOwnersRequest: {
    encode(message: PolicyOwnersRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): PolicyOwnersRequest;
    fromJSON(object: any): PolicyOwnersRequest;
    toJSON(message: PolicyOwnersRequest): unknown;
    fromPartial(object: DeepPartial<PolicyOwnersRequest>): PolicyOwnersRequest;
};
export declare const PolicyOwnersResponse: {
    encode(message: PolicyOwnersResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): PolicyOwnersResponse;
    fromJSON(object: any): PolicyOwnersResponse;
    toJSON(message: PolicyOwnersResponse): unknown;
    fromPartial(object: DeepPartial<PolicyOwnersResponse>): PolicyOwnersResponse;
};
export declare const PolicyHashesRequest: {
    encode(message: PolicyHashesRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): PolicyHashesRequest;
    fromJSON(object: any): PolicyHashesRequest;
    toJSON(message: PolicyHashesRequest): unknown;
    fromPartial(object: DeepPartial<PolicyHashesRequest>): PolicyHashesRequest;
};
export declare const PolicyHashesResponse: {
    encode(message: PolicyHashesResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): PolicyHashesResponse;
    fromJSON(object: any): PolicyHashesResponse;
    toJSON(message: PolicyHashesResponse): unknown;
    fromPartial(object: DeepPartial<PolicyHashesResponse>): PolicyHashesResponse;
};
export declare const PolicyItemDataRequest: {
    encode(message: PolicyItemDataRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): PolicyItemDataRequest;
    fromJSON(object: any): PolicyItemDataRequest;
    toJSON(message: PolicyItemDataRequest): unknown;
    fromPartial(object: DeepPartial<PolicyItemDataRequest>): PolicyItemDataRequest;
};
export declare const PolicyItemDataResponse: {
    encode(message: PolicyItemDataResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): PolicyItemDataResponse;
    fromJSON(object: any): PolicyItemDataResponse;
    toJSON(message: PolicyItemDataResponse): unknown;
    fromPartial(object: DeepPartial<PolicyItemDataResponse>): PolicyItemDataResponse;
};
export declare const PolicyItemInfoRequest: {
    encode(message: PolicyItemInfoRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): PolicyItemInfoRequest;
    fromJSON(object: any): PolicyItemInfoRequest;
    toJSON(message: PolicyItemInfoRequest): unknown;
    fromPartial(object: DeepPartial<PolicyItemInfoRequest>): PolicyItemInfoRequest;
};
export declare const PolicyItemInfoResponse: {
    encode(message: PolicyItemInfoResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): PolicyItemInfoResponse;
    fromJSON(object: any): PolicyItemInfoResponse;
    toJSON(message: PolicyItemInfoResponse): unknown;
    fromPartial(object: DeepPartial<PolicyItemInfoResponse>): PolicyItemInfoResponse;
};
export declare const PolicyItemFileInfo: {
    encode(message: PolicyItemFileInfo, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): PolicyItemFileInfo;
    fromJSON(object: any): PolicyItemFileInfo;
    toJSON(message: PolicyItemFileInfo): unknown;
    fromPartial(object: DeepPartial<PolicyItemFileInfo>): PolicyItemFileInfo;
};
export declare const PrivacyServiceService: {
    readonly getPolicyRecipients: {
        readonly path: "/wavesenterprise.PrivacyService/GetPolicyRecipients";
        readonly requestStream: false;
        readonly responseStream: false;
        readonly requestSerialize: (value: PolicyRecipientsRequest) => Buffer;
        readonly requestDeserialize: (value: Buffer) => PolicyRecipientsRequest;
        readonly responseSerialize: (value: PolicyRecipientsResponse) => Buffer;
        readonly responseDeserialize: (value: Buffer) => PolicyRecipientsResponse;
    };
    readonly getPolicyOwners: {
        readonly path: "/wavesenterprise.PrivacyService/GetPolicyOwners";
        readonly requestStream: false;
        readonly responseStream: false;
        readonly requestSerialize: (value: PolicyOwnersRequest) => Buffer;
        readonly requestDeserialize: (value: Buffer) => PolicyOwnersRequest;
        readonly responseSerialize: (value: PolicyOwnersResponse) => Buffer;
        readonly responseDeserialize: (value: Buffer) => PolicyOwnersResponse;
    };
    readonly getPolicyHashes: {
        readonly path: "/wavesenterprise.PrivacyService/GetPolicyHashes";
        readonly requestStream: false;
        readonly responseStream: false;
        readonly requestSerialize: (value: PolicyHashesRequest) => Buffer;
        readonly requestDeserialize: (value: Buffer) => PolicyHashesRequest;
        readonly responseSerialize: (value: PolicyHashesResponse) => Buffer;
        readonly responseDeserialize: (value: Buffer) => PolicyHashesResponse;
    };
    readonly getPolicyItemData: {
        readonly path: "/wavesenterprise.PrivacyService/GetPolicyItemData";
        readonly requestStream: false;
        readonly responseStream: false;
        readonly requestSerialize: (value: PolicyItemDataRequest) => Buffer;
        readonly requestDeserialize: (value: Buffer) => PolicyItemDataRequest;
        readonly responseSerialize: (value: PolicyItemDataResponse) => Buffer;
        readonly responseDeserialize: (value: Buffer) => PolicyItemDataResponse;
    };
    readonly getPolicyItemInfo: {
        readonly path: "/wavesenterprise.PrivacyService/GetPolicyItemInfo";
        readonly requestStream: false;
        readonly responseStream: false;
        readonly requestSerialize: (value: PolicyItemInfoRequest) => Buffer;
        readonly requestDeserialize: (value: Buffer) => PolicyItemInfoRequest;
        readonly responseSerialize: (value: PolicyItemInfoResponse) => Buffer;
        readonly responseDeserialize: (value: Buffer) => PolicyItemInfoResponse;
    };
};
export interface PrivacyServiceServer extends UntypedServiceImplementation {
    getPolicyRecipients: handleUnaryCall<PolicyRecipientsRequest, PolicyRecipientsResponse>;
    getPolicyOwners: handleUnaryCall<PolicyOwnersRequest, PolicyOwnersResponse>;
    getPolicyHashes: handleUnaryCall<PolicyHashesRequest, PolicyHashesResponse>;
    getPolicyItemData: handleUnaryCall<PolicyItemDataRequest, PolicyItemDataResponse>;
    getPolicyItemInfo: handleUnaryCall<PolicyItemInfoRequest, PolicyItemInfoResponse>;
}
export interface PrivacyServiceClient extends Client {
    getPolicyRecipients(request: PolicyRecipientsRequest, callback: (error: ServiceError | null, response: PolicyRecipientsResponse) => void): ClientUnaryCall;
    getPolicyRecipients(request: PolicyRecipientsRequest, metadata: Metadata, callback: (error: ServiceError | null, response: PolicyRecipientsResponse) => void): ClientUnaryCall;
    getPolicyRecipients(request: PolicyRecipientsRequest, metadata: Metadata, options: Partial<CallOptions>, callback: (error: ServiceError | null, response: PolicyRecipientsResponse) => void): ClientUnaryCall;
    getPolicyOwners(request: PolicyOwnersRequest, callback: (error: ServiceError | null, response: PolicyOwnersResponse) => void): ClientUnaryCall;
    getPolicyOwners(request: PolicyOwnersRequest, metadata: Metadata, callback: (error: ServiceError | null, response: PolicyOwnersResponse) => void): ClientUnaryCall;
    getPolicyOwners(request: PolicyOwnersRequest, metadata: Metadata, options: Partial<CallOptions>, callback: (error: ServiceError | null, response: PolicyOwnersResponse) => void): ClientUnaryCall;
    getPolicyHashes(request: PolicyHashesRequest, callback: (error: ServiceError | null, response: PolicyHashesResponse) => void): ClientUnaryCall;
    getPolicyHashes(request: PolicyHashesRequest, metadata: Metadata, callback: (error: ServiceError | null, response: PolicyHashesResponse) => void): ClientUnaryCall;
    getPolicyHashes(request: PolicyHashesRequest, metadata: Metadata, options: Partial<CallOptions>, callback: (error: ServiceError | null, response: PolicyHashesResponse) => void): ClientUnaryCall;
    getPolicyItemData(request: PolicyItemDataRequest, callback: (error: ServiceError | null, response: PolicyItemDataResponse) => void): ClientUnaryCall;
    getPolicyItemData(request: PolicyItemDataRequest, metadata: Metadata, callback: (error: ServiceError | null, response: PolicyItemDataResponse) => void): ClientUnaryCall;
    getPolicyItemData(request: PolicyItemDataRequest, metadata: Metadata, options: Partial<CallOptions>, callback: (error: ServiceError | null, response: PolicyItemDataResponse) => void): ClientUnaryCall;
    getPolicyItemInfo(request: PolicyItemInfoRequest, callback: (error: ServiceError | null, response: PolicyItemInfoResponse) => void): ClientUnaryCall;
    getPolicyItemInfo(request: PolicyItemInfoRequest, metadata: Metadata, callback: (error: ServiceError | null, response: PolicyItemInfoResponse) => void): ClientUnaryCall;
    getPolicyItemInfo(request: PolicyItemInfoRequest, metadata: Metadata, options: Partial<CallOptions>, callback: (error: ServiceError | null, response: PolicyItemInfoResponse) => void): ClientUnaryCall;
}
export declare const PrivacyServiceClient: {
    new (address: string, credentials: ChannelCredentials, options?: Partial<ChannelOptions>): PrivacyServiceClient;
    service: typeof PrivacyServiceService;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
