import Long from "long";
import { ChannelCredentials, ChannelOptions, UntypedServiceImplementation, handleUnaryCall, Client, ClientUnaryCall, Metadata, CallOptions, ServiceError } from "@grpc/grpc-js";
import * as _m0 from "protobufjs/minimal";
import { TransactionInfoRequest, TransactionInfoResponse } from "../util/util_transaction_service";
export declare const protobufPackage = "wavesenterprise";
export interface TransactionExistsRequest {
    txId?: string;
}
export interface TransactionExistsResponse {
    exists?: boolean;
}
export declare const TransactionExistsRequest: {
    encode(message: TransactionExistsRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): TransactionExistsRequest;
    fromJSON(object: any): TransactionExistsRequest;
    toJSON(message: TransactionExistsRequest): unknown;
    fromPartial(object: DeepPartial<TransactionExistsRequest>): TransactionExistsRequest;
};
export declare const TransactionExistsResponse: {
    encode(message: TransactionExistsResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): TransactionExistsResponse;
    fromJSON(object: any): TransactionExistsResponse;
    toJSON(message: TransactionExistsResponse): unknown;
    fromPartial(object: DeepPartial<TransactionExistsResponse>): TransactionExistsResponse;
};
export declare const TransactionServiceService: {
    readonly transactionExists: {
        readonly path: "/wavesenterprise.TransactionService/TransactionExists";
        readonly requestStream: false;
        readonly responseStream: false;
        readonly requestSerialize: (value: TransactionExistsRequest) => Buffer;
        readonly requestDeserialize: (value: Buffer) => TransactionExistsRequest;
        readonly responseSerialize: (value: TransactionExistsResponse) => Buffer;
        readonly responseDeserialize: (value: Buffer) => TransactionExistsResponse;
    };
    readonly transactionInfo: {
        readonly path: "/wavesenterprise.TransactionService/TransactionInfo";
        readonly requestStream: false;
        readonly responseStream: false;
        readonly requestSerialize: (value: TransactionInfoRequest) => Buffer;
        readonly requestDeserialize: (value: Buffer) => TransactionInfoRequest;
        readonly responseSerialize: (value: TransactionInfoResponse) => Buffer;
        readonly responseDeserialize: (value: Buffer) => TransactionInfoResponse;
    };
};
export interface TransactionServiceServer extends UntypedServiceImplementation {
    transactionExists: handleUnaryCall<TransactionExistsRequest, TransactionExistsResponse>;
    transactionInfo: handleUnaryCall<TransactionInfoRequest, TransactionInfoResponse>;
}
export interface TransactionServiceClient extends Client {
    transactionExists(request: TransactionExistsRequest, callback: (error: ServiceError | null, response: TransactionExistsResponse) => void): ClientUnaryCall;
    transactionExists(request: TransactionExistsRequest, metadata: Metadata, callback: (error: ServiceError | null, response: TransactionExistsResponse) => void): ClientUnaryCall;
    transactionExists(request: TransactionExistsRequest, metadata: Metadata, options: Partial<CallOptions>, callback: (error: ServiceError | null, response: TransactionExistsResponse) => void): ClientUnaryCall;
    transactionInfo(request: TransactionInfoRequest, callback: (error: ServiceError | null, response: TransactionInfoResponse) => void): ClientUnaryCall;
    transactionInfo(request: TransactionInfoRequest, metadata: Metadata, callback: (error: ServiceError | null, response: TransactionInfoResponse) => void): ClientUnaryCall;
    transactionInfo(request: TransactionInfoRequest, metadata: Metadata, options: Partial<CallOptions>, callback: (error: ServiceError | null, response: TransactionInfoResponse) => void): ClientUnaryCall;
}
export declare const TransactionServiceClient: {
    new (address: string, credentials: ChannelCredentials, options?: Partial<ChannelOptions>): TransactionServiceClient;
    service: typeof TransactionServiceService;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
