import Long from "long";
import * as _m0 from "protobufjs/minimal";
export declare const protobufPackage = "google.protobuf";
export interface FileDescriptorSet {
    file?: FileDescriptorProto[];
}
export interface FileDescriptorProto {
    name?: string;
    package?: string;
    dependency?: string[];
    publicDependency?: number[];
    weakDependency?: number[];
    messageType?: DescriptorProto[];
    enumType?: EnumDescriptorProto[];
    service?: ServiceDescriptorProto[];
    extension?: FieldDescriptorProto[];
    options?: FileOptions;
    sourceCodeInfo?: SourceCodeInfo;
    syntax?: string;
}
export interface DescriptorProto {
    name?: string;
    field?: FieldDescriptorProto[];
    extension?: FieldDescriptorProto[];
    nestedType?: DescriptorProto[];
    enumType?: EnumDescriptorProto[];
    extensionRange?: DescriptorProto_ExtensionRange[];
    oneofDecl?: OneofDescriptorProto[];
    options?: MessageOptions;
    reservedRange?: DescriptorProto_ReservedRange[];
    reservedName?: string[];
}
export interface DescriptorProto_ExtensionRange {
    start?: number;
    end?: number;
    options?: ExtensionRangeOptions;
}
export interface DescriptorProto_ReservedRange {
    start?: number;
    end?: number;
}
export interface ExtensionRangeOptions {
    uninterpretedOption?: UninterpretedOption[];
}
export interface FieldDescriptorProto {
    name?: string;
    number?: number;
    label?: FieldDescriptorProto_Label;
    type?: FieldDescriptorProto_Type;
    typeName?: string;
    extendee?: string;
    defaultValue?: string;
    oneofIndex?: number;
    jsonName?: string;
    options?: FieldOptions;
    proto3Optional?: boolean;
}
export declare enum FieldDescriptorProto_Type {
    TYPE_DOUBLE = 1,
    TYPE_FLOAT = 2,
    TYPE_INT64 = 3,
    TYPE_UINT64 = 4,
    TYPE_INT32 = 5,
    TYPE_FIXED64 = 6,
    TYPE_FIXED32 = 7,
    TYPE_BOOL = 8,
    TYPE_STRING = 9,
    TYPE_GROUP = 10,
    TYPE_MESSAGE = 11,
    TYPE_BYTES = 12,
    TYPE_UINT32 = 13,
    TYPE_ENUM = 14,
    TYPE_SFIXED32 = 15,
    TYPE_SFIXED64 = 16,
    TYPE_SINT32 = 17,
    TYPE_SINT64 = 18,
    UNRECOGNIZED = -1
}
export declare function fieldDescriptorProto_TypeFromJSON(object: any): FieldDescriptorProto_Type;
export declare function fieldDescriptorProto_TypeToJSON(object: FieldDescriptorProto_Type): string;
export declare enum FieldDescriptorProto_Label {
    LABEL_OPTIONAL = 1,
    LABEL_REQUIRED = 2,
    LABEL_REPEATED = 3,
    UNRECOGNIZED = -1
}
export declare function fieldDescriptorProto_LabelFromJSON(object: any): FieldDescriptorProto_Label;
export declare function fieldDescriptorProto_LabelToJSON(object: FieldDescriptorProto_Label): string;
export interface OneofDescriptorProto {
    name?: string;
    options?: OneofOptions;
}
export interface EnumDescriptorProto {
    name?: string;
    value?: EnumValueDescriptorProto[];
    options?: EnumOptions;
    reservedRange?: EnumDescriptorProto_EnumReservedRange[];
    reservedName?: string[];
}
export interface EnumDescriptorProto_EnumReservedRange {
    start?: number;
    end?: number;
}
export interface EnumValueDescriptorProto {
    name?: string;
    number?: number;
    options?: EnumValueOptions;
}
export interface ServiceDescriptorProto {
    name?: string;
    method?: MethodDescriptorProto[];
    options?: ServiceOptions;
}
export interface MethodDescriptorProto {
    name?: string;
    inputType?: string;
    outputType?: string;
    options?: MethodOptions;
    clientStreaming?: boolean;
    serverStreaming?: boolean;
}
export interface FileOptions {
    javaPackage?: string;
    javaOuterClassname?: string;
    javaMultipleFiles?: boolean;
    javaGenerateEqualsAndHash?: boolean;
    javaStringCheckUtf8?: boolean;
    optimizeFor?: FileOptions_OptimizeMode;
    goPackage?: string;
    ccGenericServices?: boolean;
    javaGenericServices?: boolean;
    pyGenericServices?: boolean;
    phpGenericServices?: boolean;
    deprecated?: boolean;
    ccEnableArenas?: boolean;
    objcClassPrefix?: string;
    csharpNamespace?: string;
    swiftPrefix?: string;
    phpClassPrefix?: string;
    phpNamespace?: string;
    phpMetadataNamespace?: string;
    rubyPackage?: string;
    uninterpretedOption?: UninterpretedOption[];
}
export declare enum FileOptions_OptimizeMode {
    SPEED = 1,
    CODE_SIZE = 2,
    LITE_RUNTIME = 3,
    UNRECOGNIZED = -1
}
export declare function fileOptions_OptimizeModeFromJSON(object: any): FileOptions_OptimizeMode;
export declare function fileOptions_OptimizeModeToJSON(object: FileOptions_OptimizeMode): string;
export interface MessageOptions {
    messageSetWireFormat?: boolean;
    noStandardDescriptorAccessor?: boolean;
    deprecated?: boolean;
    mapEntry?: boolean;
    uninterpretedOption?: UninterpretedOption[];
}
export interface FieldOptions {
    ctype?: FieldOptions_CType;
    packed?: boolean;
    jstype?: FieldOptions_JSType;
    lazy?: boolean;
    deprecated?: boolean;
    weak?: boolean;
    uninterpretedOption?: UninterpretedOption[];
}
export declare enum FieldOptions_CType {
    STRING = 0,
    CORD = 1,
    STRING_PIECE = 2,
    UNRECOGNIZED = -1
}
export declare function fieldOptions_CTypeFromJSON(object: any): FieldOptions_CType;
export declare function fieldOptions_CTypeToJSON(object: FieldOptions_CType): string;
export declare enum FieldOptions_JSType {
    JS_NORMAL = 0,
    JS_STRING = 1,
    JS_NUMBER = 2,
    UNRECOGNIZED = -1
}
export declare function fieldOptions_JSTypeFromJSON(object: any): FieldOptions_JSType;
export declare function fieldOptions_JSTypeToJSON(object: FieldOptions_JSType): string;
export interface OneofOptions {
    uninterpretedOption?: UninterpretedOption[];
}
export interface EnumOptions {
    allowAlias?: boolean;
    deprecated?: boolean;
    uninterpretedOption?: UninterpretedOption[];
}
export interface EnumValueOptions {
    deprecated?: boolean;
    uninterpretedOption?: UninterpretedOption[];
}
export interface ServiceOptions {
    deprecated?: boolean;
    uninterpretedOption?: UninterpretedOption[];
}
export interface MethodOptions {
    deprecated?: boolean;
    idempotencyLevel?: MethodOptions_IdempotencyLevel;
    uninterpretedOption?: UninterpretedOption[];
}
export declare enum MethodOptions_IdempotencyLevel {
    IDEMPOTENCY_UNKNOWN = 0,
    NO_SIDE_EFFECTS = 1,
    IDEMPOTENT = 2,
    UNRECOGNIZED = -1
}
export declare function methodOptions_IdempotencyLevelFromJSON(object: any): MethodOptions_IdempotencyLevel;
export declare function methodOptions_IdempotencyLevelToJSON(object: MethodOptions_IdempotencyLevel): string;
export interface UninterpretedOption {
    name?: UninterpretedOption_NamePart[];
    identifierValue?: string;
    positiveIntValue?: Long;
    negativeIntValue?: Long;
    doubleValue?: number;
    stringValue?: Uint8Array;
    aggregateValue?: string;
}
export interface UninterpretedOption_NamePart {
    namePart?: string;
    isExtension?: boolean;
}
export interface SourceCodeInfo {
    location?: SourceCodeInfo_Location[];
}
export interface SourceCodeInfo_Location {
    path?: number[];
    span?: number[];
    leadingComments?: string;
    trailingComments?: string;
    leadingDetachedComments?: string[];
}
export interface GeneratedCodeInfo {
    annotation?: GeneratedCodeInfo_Annotation[];
}
export interface GeneratedCodeInfo_Annotation {
    path?: number[];
    sourceFile?: string;
    begin?: number;
    end?: number;
}
export declare const FileDescriptorSet: {
    encode(message: FileDescriptorSet, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): FileDescriptorSet;
    fromJSON(object: any): FileDescriptorSet;
    toJSON(message: FileDescriptorSet): unknown;
    fromPartial(object: DeepPartial<FileDescriptorSet>): FileDescriptorSet;
};
export declare const FileDescriptorProto: {
    encode(message: FileDescriptorProto, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): FileDescriptorProto;
    fromJSON(object: any): FileDescriptorProto;
    toJSON(message: FileDescriptorProto): unknown;
    fromPartial(object: DeepPartial<FileDescriptorProto>): FileDescriptorProto;
};
export declare const DescriptorProto: {
    encode(message: DescriptorProto, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): DescriptorProto;
    fromJSON(object: any): DescriptorProto;
    toJSON(message: DescriptorProto): unknown;
    fromPartial(object: DeepPartial<DescriptorProto>): DescriptorProto;
};
export declare const DescriptorProto_ExtensionRange: {
    encode(message: DescriptorProto_ExtensionRange, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): DescriptorProto_ExtensionRange;
    fromJSON(object: any): DescriptorProto_ExtensionRange;
    toJSON(message: DescriptorProto_ExtensionRange): unknown;
    fromPartial(object: DeepPartial<DescriptorProto_ExtensionRange>): DescriptorProto_ExtensionRange;
};
export declare const DescriptorProto_ReservedRange: {
    encode(message: DescriptorProto_ReservedRange, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): DescriptorProto_ReservedRange;
    fromJSON(object: any): DescriptorProto_ReservedRange;
    toJSON(message: DescriptorProto_ReservedRange): unknown;
    fromPartial(object: DeepPartial<DescriptorProto_ReservedRange>): DescriptorProto_ReservedRange;
};
export declare const ExtensionRangeOptions: {
    encode(message: ExtensionRangeOptions, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): ExtensionRangeOptions;
    fromJSON(object: any): ExtensionRangeOptions;
    toJSON(message: ExtensionRangeOptions): unknown;
    fromPartial(object: DeepPartial<ExtensionRangeOptions>): ExtensionRangeOptions;
};
export declare const FieldDescriptorProto: {
    encode(message: FieldDescriptorProto, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): FieldDescriptorProto;
    fromJSON(object: any): FieldDescriptorProto;
    toJSON(message: FieldDescriptorProto): unknown;
    fromPartial(object: DeepPartial<FieldDescriptorProto>): FieldDescriptorProto;
};
export declare const OneofDescriptorProto: {
    encode(message: OneofDescriptorProto, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): OneofDescriptorProto;
    fromJSON(object: any): OneofDescriptorProto;
    toJSON(message: OneofDescriptorProto): unknown;
    fromPartial(object: DeepPartial<OneofDescriptorProto>): OneofDescriptorProto;
};
export declare const EnumDescriptorProto: {
    encode(message: EnumDescriptorProto, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): EnumDescriptorProto;
    fromJSON(object: any): EnumDescriptorProto;
    toJSON(message: EnumDescriptorProto): unknown;
    fromPartial(object: DeepPartial<EnumDescriptorProto>): EnumDescriptorProto;
};
export declare const EnumDescriptorProto_EnumReservedRange: {
    encode(message: EnumDescriptorProto_EnumReservedRange, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): EnumDescriptorProto_EnumReservedRange;
    fromJSON(object: any): EnumDescriptorProto_EnumReservedRange;
    toJSON(message: EnumDescriptorProto_EnumReservedRange): unknown;
    fromPartial(object: DeepPartial<EnumDescriptorProto_EnumReservedRange>): EnumDescriptorProto_EnumReservedRange;
};
export declare const EnumValueDescriptorProto: {
    encode(message: EnumValueDescriptorProto, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): EnumValueDescriptorProto;
    fromJSON(object: any): EnumValueDescriptorProto;
    toJSON(message: EnumValueDescriptorProto): unknown;
    fromPartial(object: DeepPartial<EnumValueDescriptorProto>): EnumValueDescriptorProto;
};
export declare const ServiceDescriptorProto: {
    encode(message: ServiceDescriptorProto, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): ServiceDescriptorProto;
    fromJSON(object: any): ServiceDescriptorProto;
    toJSON(message: ServiceDescriptorProto): unknown;
    fromPartial(object: DeepPartial<ServiceDescriptorProto>): ServiceDescriptorProto;
};
export declare const MethodDescriptorProto: {
    encode(message: MethodDescriptorProto, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MethodDescriptorProto;
    fromJSON(object: any): MethodDescriptorProto;
    toJSON(message: MethodDescriptorProto): unknown;
    fromPartial(object: DeepPartial<MethodDescriptorProto>): MethodDescriptorProto;
};
export declare const FileOptions: {
    encode(message: FileOptions, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): FileOptions;
    fromJSON(object: any): FileOptions;
    toJSON(message: FileOptions): unknown;
    fromPartial(object: DeepPartial<FileOptions>): FileOptions;
};
export declare const MessageOptions: {
    encode(message: MessageOptions, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MessageOptions;
    fromJSON(object: any): MessageOptions;
    toJSON(message: MessageOptions): unknown;
    fromPartial(object: DeepPartial<MessageOptions>): MessageOptions;
};
export declare const FieldOptions: {
    encode(message: FieldOptions, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): FieldOptions;
    fromJSON(object: any): FieldOptions;
    toJSON(message: FieldOptions): unknown;
    fromPartial(object: DeepPartial<FieldOptions>): FieldOptions;
};
export declare const OneofOptions: {
    encode(message: OneofOptions, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): OneofOptions;
    fromJSON(object: any): OneofOptions;
    toJSON(message: OneofOptions): unknown;
    fromPartial(object: DeepPartial<OneofOptions>): OneofOptions;
};
export declare const EnumOptions: {
    encode(message: EnumOptions, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): EnumOptions;
    fromJSON(object: any): EnumOptions;
    toJSON(message: EnumOptions): unknown;
    fromPartial(object: DeepPartial<EnumOptions>): EnumOptions;
};
export declare const EnumValueOptions: {
    encode(message: EnumValueOptions, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): EnumValueOptions;
    fromJSON(object: any): EnumValueOptions;
    toJSON(message: EnumValueOptions): unknown;
    fromPartial(object: DeepPartial<EnumValueOptions>): EnumValueOptions;
};
export declare const ServiceOptions: {
    encode(message: ServiceOptions, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): ServiceOptions;
    fromJSON(object: any): ServiceOptions;
    toJSON(message: ServiceOptions): unknown;
    fromPartial(object: DeepPartial<ServiceOptions>): ServiceOptions;
};
export declare const MethodOptions: {
    encode(message: MethodOptions, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MethodOptions;
    fromJSON(object: any): MethodOptions;
    toJSON(message: MethodOptions): unknown;
    fromPartial(object: DeepPartial<MethodOptions>): MethodOptions;
};
export declare const UninterpretedOption: {
    encode(message: UninterpretedOption, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): UninterpretedOption;
    fromJSON(object: any): UninterpretedOption;
    toJSON(message: UninterpretedOption): unknown;
    fromPartial(object: DeepPartial<UninterpretedOption>): UninterpretedOption;
};
export declare const UninterpretedOption_NamePart: {
    encode(message: UninterpretedOption_NamePart, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): UninterpretedOption_NamePart;
    fromJSON(object: any): UninterpretedOption_NamePart;
    toJSON(message: UninterpretedOption_NamePart): unknown;
    fromPartial(object: DeepPartial<UninterpretedOption_NamePart>): UninterpretedOption_NamePart;
};
export declare const SourceCodeInfo: {
    encode(message: SourceCodeInfo, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): SourceCodeInfo;
    fromJSON(object: any): SourceCodeInfo;
    toJSON(message: SourceCodeInfo): unknown;
    fromPartial(object: DeepPartial<SourceCodeInfo>): SourceCodeInfo;
};
export declare const SourceCodeInfo_Location: {
    encode(message: SourceCodeInfo_Location, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): SourceCodeInfo_Location;
    fromJSON(object: any): SourceCodeInfo_Location;
    toJSON(message: SourceCodeInfo_Location): unknown;
    fromPartial(object: DeepPartial<SourceCodeInfo_Location>): SourceCodeInfo_Location;
};
export declare const GeneratedCodeInfo: {
    encode(message: GeneratedCodeInfo, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): GeneratedCodeInfo;
    fromJSON(object: any): GeneratedCodeInfo;
    toJSON(message: GeneratedCodeInfo): unknown;
    fromPartial(object: DeepPartial<GeneratedCodeInfo>): GeneratedCodeInfo;
};
export declare const GeneratedCodeInfo_Annotation: {
    encode(message: GeneratedCodeInfo_Annotation, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): GeneratedCodeInfo_Annotation;
    fromJSON(object: any): GeneratedCodeInfo_Annotation;
    toJSON(message: GeneratedCodeInfo_Annotation): unknown;
    fromPartial(object: DeepPartial<GeneratedCodeInfo_Annotation>): GeneratedCodeInfo_Annotation;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
