"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AtomicTransaction = exports.protobufPackage = void 0;
const long_1 = __importDefault(require("long"));
const _m0 = __importStar(require("protobufjs/minimal"));
const atomic_inner_transaction_1 = require("../managed/atomic_inner_transaction");
const wrappers_1 = require("../google/protobuf/wrappers");
exports.protobufPackage = "wavesenterprise";
function createBaseAtomicTransaction() {
    return {
        id: new Uint8Array(),
        senderPublicKey: new Uint8Array(),
        miner: undefined,
        transactions: [],
        timestamp: long_1.default.ZERO,
        proofs: [],
        senderAddress: new Uint8Array(),
    };
}
exports.AtomicTransaction = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.id !== undefined && message.id.length !== 0) {
            writer.uint32(10).bytes(message.id);
        }
        if (message.senderPublicKey !== undefined &&
            message.senderPublicKey.length !== 0) {
            writer.uint32(18).bytes(message.senderPublicKey);
        }
        if (message.miner !== undefined) {
            wrappers_1.BytesValue.encode({ value: message.miner }, writer.uint32(26).fork()).ldelim();
        }
        if (message.transactions !== undefined &&
            message.transactions.length !== 0) {
            for (const v of message.transactions) {
                atomic_inner_transaction_1.AtomicInnerTransaction.encode(v, writer.uint32(34).fork()).ldelim();
            }
        }
        if (message.timestamp !== undefined && !message.timestamp.isZero()) {
            writer.uint32(40).int64(message.timestamp);
        }
        if (message.proofs !== undefined && message.proofs.length !== 0) {
            for (const v of message.proofs) {
                writer.uint32(50).bytes(v);
            }
        }
        if (message.senderAddress !== undefined &&
            message.senderAddress.length !== 0) {
            writer.uint32(58).bytes(message.senderAddress);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseAtomicTransaction();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.id = reader.bytes();
                    break;
                case 2:
                    message.senderPublicKey = reader.bytes();
                    break;
                case 3:
                    message.miner = wrappers_1.BytesValue.decode(reader, reader.uint32()).value;
                    break;
                case 4:
                    message.transactions.push(atomic_inner_transaction_1.AtomicInnerTransaction.decode(reader, reader.uint32()));
                    break;
                case 5:
                    message.timestamp = reader.int64();
                    break;
                case 6:
                    message.proofs.push(reader.bytes());
                    break;
                case 7:
                    message.senderAddress = reader.bytes();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            id: isSet(object.id) ? bytesFromBase64(object.id) : new Uint8Array(),
            senderPublicKey: isSet(object.senderPublicKey)
                ? bytesFromBase64(object.senderPublicKey)
                : new Uint8Array(),
            miner: isSet(object.miner) ? new Uint8Array(object.miner) : undefined,
            transactions: Array.isArray(object === null || object === void 0 ? void 0 : object.transactions)
                ? object.transactions.map((e) => atomic_inner_transaction_1.AtomicInnerTransaction.fromJSON(e))
                : [],
            timestamp: isSet(object.timestamp)
                ? long_1.default.fromString(object.timestamp)
                : long_1.default.ZERO,
            proofs: Array.isArray(object === null || object === void 0 ? void 0 : object.proofs)
                ? object.proofs.map((e) => bytesFromBase64(e))
                : [],
            senderAddress: isSet(object.senderAddress)
                ? bytesFromBase64(object.senderAddress)
                : new Uint8Array(),
        };
    },
    toJSON(message) {
        const obj = {};
        message.id !== undefined &&
            (obj.id = base64FromBytes(message.id !== undefined ? message.id : new Uint8Array()));
        message.senderPublicKey !== undefined &&
            (obj.senderPublicKey = base64FromBytes(message.senderPublicKey !== undefined
                ? message.senderPublicKey
                : new Uint8Array()));
        message.miner !== undefined && (obj.miner = message.miner);
        if (message.transactions) {
            obj.transactions = message.transactions.map((e) => e ? atomic_inner_transaction_1.AtomicInnerTransaction.toJSON(e) : undefined);
        }
        else {
            obj.transactions = [];
        }
        message.timestamp !== undefined &&
            (obj.timestamp = (message.timestamp || long_1.default.ZERO).toString());
        if (message.proofs) {
            obj.proofs = message.proofs.map((e) => base64FromBytes(e !== undefined ? e : new Uint8Array()));
        }
        else {
            obj.proofs = [];
        }
        message.senderAddress !== undefined &&
            (obj.senderAddress = base64FromBytes(message.senderAddress !== undefined
                ? message.senderAddress
                : new Uint8Array()));
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c, _d, _e, _f;
        const message = createBaseAtomicTransaction();
        message.id = (_a = object.id) !== null && _a !== void 0 ? _a : new Uint8Array();
        message.senderPublicKey = (_b = object.senderPublicKey) !== null && _b !== void 0 ? _b : new Uint8Array();
        message.miner = (_c = object.miner) !== null && _c !== void 0 ? _c : undefined;
        message.transactions =
            ((_d = object.transactions) === null || _d === void 0 ? void 0 : _d.map((e) => atomic_inner_transaction_1.AtomicInnerTransaction.fromPartial(e))) ||
                [];
        message.timestamp =
            object.timestamp !== undefined && object.timestamp !== null
                ? long_1.default.fromValue(object.timestamp)
                : long_1.default.ZERO;
        message.proofs = ((_e = object.proofs) === null || _e === void 0 ? void 0 : _e.map((e) => e)) || [];
        message.senderAddress = (_f = object.senderAddress) !== null && _f !== void 0 ? _f : new Uint8Array();
        return message;
    },
};
var globalThis = (() => {
    if (typeof globalThis !== "undefined")
        return globalThis;
    if (typeof self !== "undefined")
        return self;
    if (typeof window !== "undefined")
        return window;
    if (typeof global !== "undefined")
        return global;
    throw "Unable to locate global object";
})();
const atob = globalThis.atob ||
    ((b64) => globalThis.Buffer.from(b64, "base64").toString("binary"));
function bytesFromBase64(b64) {
    const bin = atob(b64);
    const arr = new Uint8Array(bin.length);
    for (let i = 0; i < bin.length; ++i) {
        arr[i] = bin.charCodeAt(i);
    }
    return arr;
}
const btoa = globalThis.btoa ||
    ((bin) => globalThis.Buffer.from(bin, "binary").toString("base64"));
function base64FromBytes(arr) {
    const bin = [];
    for (const byte of arr) {
        bin.push(String.fromCharCode(byte));
    }
    return btoa(bin.join(""));
}
if (_m0.util.Long !== long_1.default) {
    _m0.util.Long = long_1.default;
    _m0.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
//# sourceMappingURL=atomic_transaction.js.map