import Long from "long";
import * as _m0 from "protobufjs/minimal";
import { AtomicBadge } from "../atomic_badge";
import { ValidationPolicy } from "../validation_policy";
import { ContractApiVersion } from "../contract_api_version";
import { DataEntry } from "../data_entry";
import { ContractTransferIn } from "../contract_transfer_in";
export declare const protobufPackage = "wavesenterprise";
export interface CreateContractTransaction {
    id?: Uint8Array;
    senderPublicKey?: Uint8Array;
    image?: string;
    imageHash?: string;
    contractName?: string;
    params?: DataEntry[];
    fee?: Long;
    timestamp?: Long;
    feeAssetId?: Uint8Array;
    atomicBadge?: AtomicBadge;
    validationPolicy?: ValidationPolicy;
    apiVersion?: ContractApiVersion;
    payments?: ContractTransferIn[];
    proofs?: Uint8Array[];
    senderAddress?: Uint8Array;
}
export declare const CreateContractTransaction: {
    encode(message: CreateContractTransaction, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): CreateContractTransaction;
    fromJSON(object: any): CreateContractTransaction;
    toJSON(message: CreateContractTransaction): unknown;
    fromPartial(object: DeepPartial<CreateContractTransaction>): CreateContractTransaction;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
