"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CreateContractTransaction = exports.protobufPackage = void 0;
const long_1 = __importDefault(require("long"));
const _m0 = __importStar(require("protobufjs/minimal"));
const atomic_badge_1 = require("../atomic_badge");
const validation_policy_1 = require("../validation_policy");
const contract_api_version_1 = require("../contract_api_version");
const data_entry_1 = require("../data_entry");
const contract_transfer_in_1 = require("../contract_transfer_in");
const wrappers_1 = require("../google/protobuf/wrappers");
exports.protobufPackage = "wavesenterprise";
function createBaseCreateContractTransaction() {
    return {
        id: new Uint8Array(),
        senderPublicKey: new Uint8Array(),
        image: "",
        imageHash: "",
        contractName: "",
        params: [],
        fee: long_1.default.ZERO,
        timestamp: long_1.default.ZERO,
        feeAssetId: undefined,
        atomicBadge: undefined,
        validationPolicy: undefined,
        apiVersion: undefined,
        payments: [],
        proofs: [],
        senderAddress: new Uint8Array(),
    };
}
exports.CreateContractTransaction = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.id !== undefined && message.id.length !== 0) {
            writer.uint32(10).bytes(message.id);
        }
        if (message.senderPublicKey !== undefined &&
            message.senderPublicKey.length !== 0) {
            writer.uint32(18).bytes(message.senderPublicKey);
        }
        if (message.image !== undefined && message.image !== "") {
            writer.uint32(26).string(message.image);
        }
        if (message.imageHash !== undefined && message.imageHash !== "") {
            writer.uint32(34).string(message.imageHash);
        }
        if (message.contractName !== undefined && message.contractName !== "") {
            writer.uint32(42).string(message.contractName);
        }
        if (message.params !== undefined && message.params.length !== 0) {
            for (const v of message.params) {
                data_entry_1.DataEntry.encode(v, writer.uint32(50).fork()).ldelim();
            }
        }
        if (message.fee !== undefined && !message.fee.isZero()) {
            writer.uint32(56).int64(message.fee);
        }
        if (message.timestamp !== undefined && !message.timestamp.isZero()) {
            writer.uint32(64).int64(message.timestamp);
        }
        if (message.feeAssetId !== undefined) {
            wrappers_1.BytesValue.encode({ value: message.feeAssetId }, writer.uint32(74).fork()).ldelim();
        }
        if (message.atomicBadge !== undefined) {
            atomic_badge_1.AtomicBadge.encode(message.atomicBadge, writer.uint32(82).fork()).ldelim();
        }
        if (message.validationPolicy !== undefined) {
            validation_policy_1.ValidationPolicy.encode(message.validationPolicy, writer.uint32(90).fork()).ldelim();
        }
        if (message.apiVersion !== undefined) {
            contract_api_version_1.ContractApiVersion.encode(message.apiVersion, writer.uint32(98).fork()).ldelim();
        }
        if (message.payments !== undefined && message.payments.length !== 0) {
            for (const v of message.payments) {
                contract_transfer_in_1.ContractTransferIn.encode(v, writer.uint32(106).fork()).ldelim();
            }
        }
        if (message.proofs !== undefined && message.proofs.length !== 0) {
            for (const v of message.proofs) {
                writer.uint32(114).bytes(v);
            }
        }
        if (message.senderAddress !== undefined &&
            message.senderAddress.length !== 0) {
            writer.uint32(122).bytes(message.senderAddress);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseCreateContractTransaction();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.id = reader.bytes();
                    break;
                case 2:
                    message.senderPublicKey = reader.bytes();
                    break;
                case 3:
                    message.image = reader.string();
                    break;
                case 4:
                    message.imageHash = reader.string();
                    break;
                case 5:
                    message.contractName = reader.string();
                    break;
                case 6:
                    message.params.push(data_entry_1.DataEntry.decode(reader, reader.uint32()));
                    break;
                case 7:
                    message.fee = reader.int64();
                    break;
                case 8:
                    message.timestamp = reader.int64();
                    break;
                case 9:
                    message.feeAssetId = wrappers_1.BytesValue.decode(reader, reader.uint32()).value;
                    break;
                case 10:
                    message.atomicBadge = atomic_badge_1.AtomicBadge.decode(reader, reader.uint32());
                    break;
                case 11:
                    message.validationPolicy = validation_policy_1.ValidationPolicy.decode(reader, reader.uint32());
                    break;
                case 12:
                    message.apiVersion = contract_api_version_1.ContractApiVersion.decode(reader, reader.uint32());
                    break;
                case 13:
                    message.payments.push(contract_transfer_in_1.ContractTransferIn.decode(reader, reader.uint32()));
                    break;
                case 14:
                    message.proofs.push(reader.bytes());
                    break;
                case 15:
                    message.senderAddress = reader.bytes();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            id: isSet(object.id) ? bytesFromBase64(object.id) : new Uint8Array(),
            senderPublicKey: isSet(object.senderPublicKey)
                ? bytesFromBase64(object.senderPublicKey)
                : new Uint8Array(),
            image: isSet(object.image) ? String(object.image) : "",
            imageHash: isSet(object.imageHash) ? String(object.imageHash) : "",
            contractName: isSet(object.contractName)
                ? String(object.contractName)
                : "",
            params: Array.isArray(object === null || object === void 0 ? void 0 : object.params)
                ? object.params.map((e) => data_entry_1.DataEntry.fromJSON(e))
                : [],
            fee: isSet(object.fee) ? long_1.default.fromString(object.fee) : long_1.default.ZERO,
            timestamp: isSet(object.timestamp)
                ? long_1.default.fromString(object.timestamp)
                : long_1.default.ZERO,
            feeAssetId: isSet(object.feeAssetId)
                ? new Uint8Array(object.feeAssetId)
                : undefined,
            atomicBadge: isSet(object.atomicBadge)
                ? atomic_badge_1.AtomicBadge.fromJSON(object.atomicBadge)
                : undefined,
            validationPolicy: isSet(object.validationPolicy)
                ? validation_policy_1.ValidationPolicy.fromJSON(object.validationPolicy)
                : undefined,
            apiVersion: isSet(object.apiVersion)
                ? contract_api_version_1.ContractApiVersion.fromJSON(object.apiVersion)
                : undefined,
            payments: Array.isArray(object === null || object === void 0 ? void 0 : object.payments)
                ? object.payments.map((e) => contract_transfer_in_1.ContractTransferIn.fromJSON(e))
                : [],
            proofs: Array.isArray(object === null || object === void 0 ? void 0 : object.proofs)
                ? object.proofs.map((e) => bytesFromBase64(e))
                : [],
            senderAddress: isSet(object.senderAddress)
                ? bytesFromBase64(object.senderAddress)
                : new Uint8Array(),
        };
    },
    toJSON(message) {
        const obj = {};
        message.id !== undefined &&
            (obj.id = base64FromBytes(message.id !== undefined ? message.id : new Uint8Array()));
        message.senderPublicKey !== undefined &&
            (obj.senderPublicKey = base64FromBytes(message.senderPublicKey !== undefined
                ? message.senderPublicKey
                : new Uint8Array()));
        message.image !== undefined && (obj.image = message.image);
        message.imageHash !== undefined && (obj.imageHash = message.imageHash);
        message.contractName !== undefined &&
            (obj.contractName = message.contractName);
        if (message.params) {
            obj.params = message.params.map((e) => e ? data_entry_1.DataEntry.toJSON(e) : undefined);
        }
        else {
            obj.params = [];
        }
        message.fee !== undefined &&
            (obj.fee = (message.fee || long_1.default.ZERO).toString());
        message.timestamp !== undefined &&
            (obj.timestamp = (message.timestamp || long_1.default.ZERO).toString());
        message.feeAssetId !== undefined && (obj.feeAssetId = message.feeAssetId);
        message.atomicBadge !== undefined &&
            (obj.atomicBadge = message.atomicBadge
                ? atomic_badge_1.AtomicBadge.toJSON(message.atomicBadge)
                : undefined);
        message.validationPolicy !== undefined &&
            (obj.validationPolicy = message.validationPolicy
                ? validation_policy_1.ValidationPolicy.toJSON(message.validationPolicy)
                : undefined);
        message.apiVersion !== undefined &&
            (obj.apiVersion = message.apiVersion
                ? contract_api_version_1.ContractApiVersion.toJSON(message.apiVersion)
                : undefined);
        if (message.payments) {
            obj.payments = message.payments.map((e) => e ? contract_transfer_in_1.ContractTransferIn.toJSON(e) : undefined);
        }
        else {
            obj.payments = [];
        }
        if (message.proofs) {
            obj.proofs = message.proofs.map((e) => base64FromBytes(e !== undefined ? e : new Uint8Array()));
        }
        else {
            obj.proofs = [];
        }
        message.senderAddress !== undefined &&
            (obj.senderAddress = base64FromBytes(message.senderAddress !== undefined
                ? message.senderAddress
                : new Uint8Array()));
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
        const message = createBaseCreateContractTransaction();
        message.id = (_a = object.id) !== null && _a !== void 0 ? _a : new Uint8Array();
        message.senderPublicKey = (_b = object.senderPublicKey) !== null && _b !== void 0 ? _b : new Uint8Array();
        message.image = (_c = object.image) !== null && _c !== void 0 ? _c : "";
        message.imageHash = (_d = object.imageHash) !== null && _d !== void 0 ? _d : "";
        message.contractName = (_e = object.contractName) !== null && _e !== void 0 ? _e : "";
        message.params = ((_f = object.params) === null || _f === void 0 ? void 0 : _f.map((e) => data_entry_1.DataEntry.fromPartial(e))) || [];
        message.fee =
            object.fee !== undefined && object.fee !== null
                ? long_1.default.fromValue(object.fee)
                : long_1.default.ZERO;
        message.timestamp =
            object.timestamp !== undefined && object.timestamp !== null
                ? long_1.default.fromValue(object.timestamp)
                : long_1.default.ZERO;
        message.feeAssetId = (_g = object.feeAssetId) !== null && _g !== void 0 ? _g : undefined;
        message.atomicBadge =
            object.atomicBadge !== undefined && object.atomicBadge !== null
                ? atomic_badge_1.AtomicBadge.fromPartial(object.atomicBadge)
                : undefined;
        message.validationPolicy =
            object.validationPolicy !== undefined && object.validationPolicy !== null
                ? validation_policy_1.ValidationPolicy.fromPartial(object.validationPolicy)
                : undefined;
        message.apiVersion =
            object.apiVersion !== undefined && object.apiVersion !== null
                ? contract_api_version_1.ContractApiVersion.fromPartial(object.apiVersion)
                : undefined;
        message.payments =
            ((_h = object.payments) === null || _h === void 0 ? void 0 : _h.map((e) => contract_transfer_in_1.ContractTransferIn.fromPartial(e))) || [];
        message.proofs = ((_j = object.proofs) === null || _j === void 0 ? void 0 : _j.map((e) => e)) || [];
        message.senderAddress = (_k = object.senderAddress) !== null && _k !== void 0 ? _k : new Uint8Array();
        return message;
    },
};
var globalThis = (() => {
    if (typeof globalThis !== "undefined")
        return globalThis;
    if (typeof self !== "undefined")
        return self;
    if (typeof window !== "undefined")
        return window;
    if (typeof global !== "undefined")
        return global;
    throw "Unable to locate global object";
})();
const atob = globalThis.atob ||
    ((b64) => globalThis.Buffer.from(b64, "base64").toString("binary"));
function bytesFromBase64(b64) {
    const bin = atob(b64);
    const arr = new Uint8Array(bin.length);
    for (let i = 0; i < bin.length; ++i) {
        arr[i] = bin.charCodeAt(i);
    }
    return arr;
}
const btoa = globalThis.btoa ||
    ((bin) => globalThis.Buffer.from(bin, "binary").toString("base64"));
function base64FromBytes(arr) {
    const bin = [];
    for (const byte of arr) {
        bin.push(String.fromCharCode(byte));
    }
    return btoa(bin.join(""));
}
if (_m0.util.Long !== long_1.default) {
    _m0.util.Long = long_1.default;
    _m0.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
//# sourceMappingURL=create_contract_transaction.js.map