"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ExecutedContractTransaction = exports.protobufPackage = void 0;
const long_1 = __importDefault(require("long"));
const _m0 = __importStar(require("protobufjs/minimal"));
const executable_contract_transaction_1 = require("../executable_contract_transaction");
const data_entry_1 = require("../data_entry");
const validation_proof_1 = require("../validation_proof");
const contract_asset_operation_1 = require("../contract_asset_operation");
exports.protobufPackage = "wavesenterprise";
function createBaseExecutedContractTransaction() {
    return {
        id: new Uint8Array(),
        senderPublicKey: new Uint8Array(),
        tx: undefined,
        results: [],
        resultsHash: new Uint8Array(),
        validationProofs: [],
        timestamp: long_1.default.ZERO,
        assetOperations: [],
        proofs: [],
        senderAddress: new Uint8Array(),
    };
}
exports.ExecutedContractTransaction = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.id !== undefined && message.id.length !== 0) {
            writer.uint32(10).bytes(message.id);
        }
        if (message.senderPublicKey !== undefined &&
            message.senderPublicKey.length !== 0) {
            writer.uint32(18).bytes(message.senderPublicKey);
        }
        if (message.tx !== undefined) {
            executable_contract_transaction_1.ExecutableTransaction.encode(message.tx, writer.uint32(26).fork()).ldelim();
        }
        if (message.results !== undefined && message.results.length !== 0) {
            for (const v of message.results) {
                data_entry_1.DataEntry.encode(v, writer.uint32(34).fork()).ldelim();
            }
        }
        if (message.resultsHash !== undefined && message.resultsHash.length !== 0) {
            writer.uint32(42).bytes(message.resultsHash);
        }
        if (message.validationProofs !== undefined &&
            message.validationProofs.length !== 0) {
            for (const v of message.validationProofs) {
                validation_proof_1.ValidationProof.encode(v, writer.uint32(50).fork()).ldelim();
            }
        }
        if (message.timestamp !== undefined && !message.timestamp.isZero()) {
            writer.uint32(56).int64(message.timestamp);
        }
        if (message.assetOperations !== undefined &&
            message.assetOperations.length !== 0) {
            for (const v of message.assetOperations) {
                contract_asset_operation_1.ContractAssetOperation.encode(v, writer.uint32(66).fork()).ldelim();
            }
        }
        if (message.proofs !== undefined && message.proofs.length !== 0) {
            for (const v of message.proofs) {
                writer.uint32(74).bytes(v);
            }
        }
        if (message.senderAddress !== undefined &&
            message.senderAddress.length !== 0) {
            writer.uint32(82).bytes(message.senderAddress);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseExecutedContractTransaction();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.id = reader.bytes();
                    break;
                case 2:
                    message.senderPublicKey = reader.bytes();
                    break;
                case 3:
                    message.tx = executable_contract_transaction_1.ExecutableTransaction.decode(reader, reader.uint32());
                    break;
                case 4:
                    message.results.push(data_entry_1.DataEntry.decode(reader, reader.uint32()));
                    break;
                case 5:
                    message.resultsHash = reader.bytes();
                    break;
                case 6:
                    message.validationProofs.push(validation_proof_1.ValidationProof.decode(reader, reader.uint32()));
                    break;
                case 7:
                    message.timestamp = reader.int64();
                    break;
                case 8:
                    message.assetOperations.push(contract_asset_operation_1.ContractAssetOperation.decode(reader, reader.uint32()));
                    break;
                case 9:
                    message.proofs.push(reader.bytes());
                    break;
                case 10:
                    message.senderAddress = reader.bytes();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            id: isSet(object.id) ? bytesFromBase64(object.id) : new Uint8Array(),
            senderPublicKey: isSet(object.senderPublicKey)
                ? bytesFromBase64(object.senderPublicKey)
                : new Uint8Array(),
            tx: isSet(object.tx)
                ? executable_contract_transaction_1.ExecutableTransaction.fromJSON(object.tx)
                : undefined,
            results: Array.isArray(object === null || object === void 0 ? void 0 : object.results)
                ? object.results.map((e) => data_entry_1.DataEntry.fromJSON(e))
                : [],
            resultsHash: isSet(object.resultsHash)
                ? bytesFromBase64(object.resultsHash)
                : new Uint8Array(),
            validationProofs: Array.isArray(object === null || object === void 0 ? void 0 : object.validationProofs)
                ? object.validationProofs.map((e) => validation_proof_1.ValidationProof.fromJSON(e))
                : [],
            timestamp: isSet(object.timestamp)
                ? long_1.default.fromString(object.timestamp)
                : long_1.default.ZERO,
            assetOperations: Array.isArray(object === null || object === void 0 ? void 0 : object.assetOperations)
                ? object.assetOperations.map((e) => contract_asset_operation_1.ContractAssetOperation.fromJSON(e))
                : [],
            proofs: Array.isArray(object === null || object === void 0 ? void 0 : object.proofs)
                ? object.proofs.map((e) => bytesFromBase64(e))
                : [],
            senderAddress: isSet(object.senderAddress)
                ? bytesFromBase64(object.senderAddress)
                : new Uint8Array(),
        };
    },
    toJSON(message) {
        const obj = {};
        message.id !== undefined &&
            (obj.id = base64FromBytes(message.id !== undefined ? message.id : new Uint8Array()));
        message.senderPublicKey !== undefined &&
            (obj.senderPublicKey = base64FromBytes(message.senderPublicKey !== undefined
                ? message.senderPublicKey
                : new Uint8Array()));
        message.tx !== undefined &&
            (obj.tx = message.tx
                ? executable_contract_transaction_1.ExecutableTransaction.toJSON(message.tx)
                : undefined);
        if (message.results) {
            obj.results = message.results.map((e) => e ? data_entry_1.DataEntry.toJSON(e) : undefined);
        }
        else {
            obj.results = [];
        }
        message.resultsHash !== undefined &&
            (obj.resultsHash = base64FromBytes(message.resultsHash !== undefined
                ? message.resultsHash
                : new Uint8Array()));
        if (message.validationProofs) {
            obj.validationProofs = message.validationProofs.map((e) => e ? validation_proof_1.ValidationProof.toJSON(e) : undefined);
        }
        else {
            obj.validationProofs = [];
        }
        message.timestamp !== undefined &&
            (obj.timestamp = (message.timestamp || long_1.default.ZERO).toString());
        if (message.assetOperations) {
            obj.assetOperations = message.assetOperations.map((e) => e ? contract_asset_operation_1.ContractAssetOperation.toJSON(e) : undefined);
        }
        else {
            obj.assetOperations = [];
        }
        if (message.proofs) {
            obj.proofs = message.proofs.map((e) => base64FromBytes(e !== undefined ? e : new Uint8Array()));
        }
        else {
            obj.proofs = [];
        }
        message.senderAddress !== undefined &&
            (obj.senderAddress = base64FromBytes(message.senderAddress !== undefined
                ? message.senderAddress
                : new Uint8Array()));
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c, _d, _e, _f, _g, _h;
        const message = createBaseExecutedContractTransaction();
        message.id = (_a = object.id) !== null && _a !== void 0 ? _a : new Uint8Array();
        message.senderPublicKey = (_b = object.senderPublicKey) !== null && _b !== void 0 ? _b : new Uint8Array();
        message.tx =
            object.tx !== undefined && object.tx !== null
                ? executable_contract_transaction_1.ExecutableTransaction.fromPartial(object.tx)
                : undefined;
        message.results =
            ((_c = object.results) === null || _c === void 0 ? void 0 : _c.map((e) => data_entry_1.DataEntry.fromPartial(e))) || [];
        message.resultsHash = (_d = object.resultsHash) !== null && _d !== void 0 ? _d : new Uint8Array();
        message.validationProofs =
            ((_e = object.validationProofs) === null || _e === void 0 ? void 0 : _e.map((e) => validation_proof_1.ValidationProof.fromPartial(e))) || [];
        message.timestamp =
            object.timestamp !== undefined && object.timestamp !== null
                ? long_1.default.fromValue(object.timestamp)
                : long_1.default.ZERO;
        message.assetOperations =
            ((_f = object.assetOperations) === null || _f === void 0 ? void 0 : _f.map((e) => contract_asset_operation_1.ContractAssetOperation.fromPartial(e))) || [];
        message.proofs = ((_g = object.proofs) === null || _g === void 0 ? void 0 : _g.map((e) => e)) || [];
        message.senderAddress = (_h = object.senderAddress) !== null && _h !== void 0 ? _h : new Uint8Array();
        return message;
    },
};
var globalThis = (() => {
    if (typeof globalThis !== "undefined")
        return globalThis;
    if (typeof self !== "undefined")
        return self;
    if (typeof window !== "undefined")
        return window;
    if (typeof global !== "undefined")
        return global;
    throw "Unable to locate global object";
})();
const atob = globalThis.atob ||
    ((b64) => globalThis.Buffer.from(b64, "base64").toString("binary"));
function bytesFromBase64(b64) {
    const bin = atob(b64);
    const arr = new Uint8Array(bin.length);
    for (let i = 0; i < bin.length; ++i) {
        arr[i] = bin.charCodeAt(i);
    }
    return arr;
}
const btoa = globalThis.btoa ||
    ((bin) => globalThis.Buffer.from(bin, "binary").toString("base64"));
function base64FromBytes(arr) {
    const bin = [];
    for (const byte of arr) {
        bin.push(String.fromCharCode(byte));
    }
    return btoa(bin.join(""));
}
if (_m0.util.Long !== long_1.default) {
    _m0.util.Long = long_1.default;
    _m0.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
//# sourceMappingURL=executed_contract_transaction.js.map