"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MassTransferTransaction = exports.protobufPackage = void 0;
const long_1 = __importDefault(require("long"));
const _m0 = __importStar(require("protobufjs/minimal"));
const transfer_1 = require("../transfer");
const wrappers_1 = require("../google/protobuf/wrappers");
exports.protobufPackage = "wavesenterprise";
function createBaseMassTransferTransaction() {
    return {
        id: new Uint8Array(),
        senderPublicKey: new Uint8Array(),
        assetId: undefined,
        transfers: [],
        timestamp: long_1.default.ZERO,
        fee: long_1.default.ZERO,
        attachment: new Uint8Array(),
        feeAssetId: undefined,
        proofs: [],
        senderAddress: new Uint8Array(),
    };
}
exports.MassTransferTransaction = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.id !== undefined && message.id.length !== 0) {
            writer.uint32(10).bytes(message.id);
        }
        if (message.senderPublicKey !== undefined &&
            message.senderPublicKey.length !== 0) {
            writer.uint32(18).bytes(message.senderPublicKey);
        }
        if (message.assetId !== undefined) {
            wrappers_1.BytesValue.encode({ value: message.assetId }, writer.uint32(26).fork()).ldelim();
        }
        if (message.transfers !== undefined && message.transfers.length !== 0) {
            for (const v of message.transfers) {
                transfer_1.Transfer.encode(v, writer.uint32(34).fork()).ldelim();
            }
        }
        if (message.timestamp !== undefined && !message.timestamp.isZero()) {
            writer.uint32(40).int64(message.timestamp);
        }
        if (message.fee !== undefined && !message.fee.isZero()) {
            writer.uint32(48).int64(message.fee);
        }
        if (message.attachment !== undefined && message.attachment.length !== 0) {
            writer.uint32(58).bytes(message.attachment);
        }
        if (message.feeAssetId !== undefined) {
            wrappers_1.BytesValue.encode({ value: message.feeAssetId }, writer.uint32(66).fork()).ldelim();
        }
        if (message.proofs !== undefined && message.proofs.length !== 0) {
            for (const v of message.proofs) {
                writer.uint32(74).bytes(v);
            }
        }
        if (message.senderAddress !== undefined &&
            message.senderAddress.length !== 0) {
            writer.uint32(82).bytes(message.senderAddress);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMassTransferTransaction();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.id = reader.bytes();
                    break;
                case 2:
                    message.senderPublicKey = reader.bytes();
                    break;
                case 3:
                    message.assetId = wrappers_1.BytesValue.decode(reader, reader.uint32()).value;
                    break;
                case 4:
                    message.transfers.push(transfer_1.Transfer.decode(reader, reader.uint32()));
                    break;
                case 5:
                    message.timestamp = reader.int64();
                    break;
                case 6:
                    message.fee = reader.int64();
                    break;
                case 7:
                    message.attachment = reader.bytes();
                    break;
                case 8:
                    message.feeAssetId = wrappers_1.BytesValue.decode(reader, reader.uint32()).value;
                    break;
                case 9:
                    message.proofs.push(reader.bytes());
                    break;
                case 10:
                    message.senderAddress = reader.bytes();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            id: isSet(object.id) ? bytesFromBase64(object.id) : new Uint8Array(),
            senderPublicKey: isSet(object.senderPublicKey)
                ? bytesFromBase64(object.senderPublicKey)
                : new Uint8Array(),
            assetId: isSet(object.assetId)
                ? new Uint8Array(object.assetId)
                : undefined,
            transfers: Array.isArray(object === null || object === void 0 ? void 0 : object.transfers)
                ? object.transfers.map((e) => transfer_1.Transfer.fromJSON(e))
                : [],
            timestamp: isSet(object.timestamp)
                ? long_1.default.fromString(object.timestamp)
                : long_1.default.ZERO,
            fee: isSet(object.fee) ? long_1.default.fromString(object.fee) : long_1.default.ZERO,
            attachment: isSet(object.attachment)
                ? bytesFromBase64(object.attachment)
                : new Uint8Array(),
            feeAssetId: isSet(object.feeAssetId)
                ? new Uint8Array(object.feeAssetId)
                : undefined,
            proofs: Array.isArray(object === null || object === void 0 ? void 0 : object.proofs)
                ? object.proofs.map((e) => bytesFromBase64(e))
                : [],
            senderAddress: isSet(object.senderAddress)
                ? bytesFromBase64(object.senderAddress)
                : new Uint8Array(),
        };
    },
    toJSON(message) {
        const obj = {};
        message.id !== undefined &&
            (obj.id = base64FromBytes(message.id !== undefined ? message.id : new Uint8Array()));
        message.senderPublicKey !== undefined &&
            (obj.senderPublicKey = base64FromBytes(message.senderPublicKey !== undefined
                ? message.senderPublicKey
                : new Uint8Array()));
        message.assetId !== undefined && (obj.assetId = message.assetId);
        if (message.transfers) {
            obj.transfers = message.transfers.map((e) => e ? transfer_1.Transfer.toJSON(e) : undefined);
        }
        else {
            obj.transfers = [];
        }
        message.timestamp !== undefined &&
            (obj.timestamp = (message.timestamp || long_1.default.ZERO).toString());
        message.fee !== undefined &&
            (obj.fee = (message.fee || long_1.default.ZERO).toString());
        message.attachment !== undefined &&
            (obj.attachment = base64FromBytes(message.attachment !== undefined ? message.attachment : new Uint8Array()));
        message.feeAssetId !== undefined && (obj.feeAssetId = message.feeAssetId);
        if (message.proofs) {
            obj.proofs = message.proofs.map((e) => base64FromBytes(e !== undefined ? e : new Uint8Array()));
        }
        else {
            obj.proofs = [];
        }
        message.senderAddress !== undefined &&
            (obj.senderAddress = base64FromBytes(message.senderAddress !== undefined
                ? message.senderAddress
                : new Uint8Array()));
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c, _d, _e, _f, _g, _h;
        const message = createBaseMassTransferTransaction();
        message.id = (_a = object.id) !== null && _a !== void 0 ? _a : new Uint8Array();
        message.senderPublicKey = (_b = object.senderPublicKey) !== null && _b !== void 0 ? _b : new Uint8Array();
        message.assetId = (_c = object.assetId) !== null && _c !== void 0 ? _c : undefined;
        message.transfers =
            ((_d = object.transfers) === null || _d === void 0 ? void 0 : _d.map((e) => transfer_1.Transfer.fromPartial(e))) || [];
        message.timestamp =
            object.timestamp !== undefined && object.timestamp !== null
                ? long_1.default.fromValue(object.timestamp)
                : long_1.default.ZERO;
        message.fee =
            object.fee !== undefined && object.fee !== null
                ? long_1.default.fromValue(object.fee)
                : long_1.default.ZERO;
        message.attachment = (_e = object.attachment) !== null && _e !== void 0 ? _e : new Uint8Array();
        message.feeAssetId = (_f = object.feeAssetId) !== null && _f !== void 0 ? _f : undefined;
        message.proofs = ((_g = object.proofs) === null || _g === void 0 ? void 0 : _g.map((e) => e)) || [];
        message.senderAddress = (_h = object.senderAddress) !== null && _h !== void 0 ? _h : new Uint8Array();
        return message;
    },
};
var globalThis = (() => {
    if (typeof globalThis !== "undefined")
        return globalThis;
    if (typeof self !== "undefined")
        return self;
    if (typeof window !== "undefined")
        return window;
    if (typeof global !== "undefined")
        return global;
    throw "Unable to locate global object";
})();
const atob = globalThis.atob ||
    ((b64) => globalThis.Buffer.from(b64, "base64").toString("binary"));
function bytesFromBase64(b64) {
    const bin = atob(b64);
    const arr = new Uint8Array(bin.length);
    for (let i = 0; i < bin.length; ++i) {
        arr[i] = bin.charCodeAt(i);
    }
    return arr;
}
const btoa = globalThis.btoa ||
    ((bin) => globalThis.Buffer.from(bin, "binary").toString("base64"));
function base64FromBytes(arr) {
    const bin = [];
    for (const byte of arr) {
        bin.push(String.fromCharCode(byte));
    }
    return btoa(bin.join(""));
}
if (_m0.util.Long !== long_1.default) {
    _m0.util.Long = long_1.default;
    _m0.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
//# sourceMappingURL=mass_transfer_transaction.js.map