import Long from "long";
import * as _m0 from "protobufjs/minimal";
import { Transaction } from "../managed/transaction";
export declare const protobufPackage = "wavesenterprise";
export interface BlockchainEvent {
    microBlockAppended?: MicroBlockAppended | undefined;
    blockAppended?: BlockAppended | undefined;
    rollbackCompleted?: RollbackCompleted | undefined;
    appendedBlockHistory?: AppendedBlockHistory | undefined;
}
export interface GenericError {
}
export interface BlockSignatureNotFoundError {
    blockSignature?: Uint8Array;
}
export interface MissingRequiredRequestField {
}
export interface MissingAuthorizationMetadata {
}
export interface InvalidApiKey {
}
export interface InvalidToken {
}
export interface MicroBlockAppended {
    txs?: Transaction[];
}
export interface BlockAppended {
    blockSignature?: Uint8Array;
    reference?: Uint8Array;
    txIds?: Uint8Array[];
    minerAddress?: Uint8Array;
    height?: Long;
    version?: number;
    timestamp?: Long;
    fee?: Long;
    blockSize?: number;
    features?: number[];
}
export interface RollbackCompleted {
    returnToBlockSignature?: Uint8Array;
    rollbackTxIds?: Uint8Array[];
}
export interface AppendedBlockHistory {
    blockSignature?: Uint8Array;
    reference?: Uint8Array;
    txs?: Transaction[];
    minerAddress?: Uint8Array;
    height?: Long;
    version?: number;
    timestamp?: Long;
    fee?: Long;
    blockSize?: number;
    features?: number[];
}
export declare const BlockchainEvent: {
    encode(message: BlockchainEvent, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): BlockchainEvent;
    fromJSON(object: any): BlockchainEvent;
    toJSON(message: BlockchainEvent): unknown;
    fromPartial(object: DeepPartial<BlockchainEvent>): BlockchainEvent;
};
export declare const GenericError: {
    encode(_: GenericError, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): GenericError;
    fromJSON(_: any): GenericError;
    toJSON(_: GenericError): unknown;
    fromPartial(_: DeepPartial<GenericError>): GenericError;
};
export declare const BlockSignatureNotFoundError: {
    encode(message: BlockSignatureNotFoundError, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): BlockSignatureNotFoundError;
    fromJSON(object: any): BlockSignatureNotFoundError;
    toJSON(message: BlockSignatureNotFoundError): unknown;
    fromPartial(object: DeepPartial<BlockSignatureNotFoundError>): BlockSignatureNotFoundError;
};
export declare const MissingRequiredRequestField: {
    encode(_: MissingRequiredRequestField, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MissingRequiredRequestField;
    fromJSON(_: any): MissingRequiredRequestField;
    toJSON(_: MissingRequiredRequestField): unknown;
    fromPartial(_: DeepPartial<MissingRequiredRequestField>): MissingRequiredRequestField;
};
export declare const MissingAuthorizationMetadata: {
    encode(_: MissingAuthorizationMetadata, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MissingAuthorizationMetadata;
    fromJSON(_: any): MissingAuthorizationMetadata;
    toJSON(_: MissingAuthorizationMetadata): unknown;
    fromPartial(_: DeepPartial<MissingAuthorizationMetadata>): MissingAuthorizationMetadata;
};
export declare const InvalidApiKey: {
    encode(_: InvalidApiKey, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): InvalidApiKey;
    fromJSON(_: any): InvalidApiKey;
    toJSON(_: InvalidApiKey): unknown;
    fromPartial(_: DeepPartial<InvalidApiKey>): InvalidApiKey;
};
export declare const InvalidToken: {
    encode(_: InvalidToken, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): InvalidToken;
    fromJSON(_: any): InvalidToken;
    toJSON(_: InvalidToken): unknown;
    fromPartial(_: DeepPartial<InvalidToken>): InvalidToken;
};
export declare const MicroBlockAppended: {
    encode(message: MicroBlockAppended, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MicroBlockAppended;
    fromJSON(object: any): MicroBlockAppended;
    toJSON(message: MicroBlockAppended): unknown;
    fromPartial(object: DeepPartial<MicroBlockAppended>): MicroBlockAppended;
};
export declare const BlockAppended: {
    encode(message: BlockAppended, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): BlockAppended;
    fromJSON(object: any): BlockAppended;
    toJSON(message: BlockAppended): unknown;
    fromPartial(object: DeepPartial<BlockAppended>): BlockAppended;
};
export declare const RollbackCompleted: {
    encode(message: RollbackCompleted, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): RollbackCompleted;
    fromJSON(object: any): RollbackCompleted;
    toJSON(message: RollbackCompleted): unknown;
    fromPartial(object: DeepPartial<RollbackCompleted>): RollbackCompleted;
};
export declare const AppendedBlockHistory: {
    encode(message: AppendedBlockHistory, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): AppendedBlockHistory;
    fromJSON(object: any): AppendedBlockHistory;
    toJSON(message: AppendedBlockHistory): unknown;
    fromPartial(object: DeepPartial<AppendedBlockHistory>): AppendedBlockHistory;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
