import { ChannelCredentials, ChannelOptions, UntypedServiceImplementation, handleServerStreamingCall, Client, CallOptions, ClientReadableStream, Metadata } from "@grpc/grpc-js";
import { SubscribeOnRequest } from "../util/events/util_events_subscribe_on_request";
import { BlockchainEvent } from "../messagebroker/messagebroker_blockchain_event";
export declare const protobufPackage = "wavesenterprise";
export declare const BlockchainEventsServiceService: {
    readonly subscribeOn: {
        readonly path: "/wavesenterprise.BlockchainEventsService/SubscribeOn";
        readonly requestStream: false;
        readonly responseStream: true;
        readonly requestSerialize: (value: SubscribeOnRequest) => Buffer;
        readonly requestDeserialize: (value: Buffer) => SubscribeOnRequest;
        readonly responseSerialize: (value: BlockchainEvent) => Buffer;
        readonly responseDeserialize: (value: Buffer) => BlockchainEvent;
    };
};
export interface BlockchainEventsServiceServer extends UntypedServiceImplementation {
    subscribeOn: handleServerStreamingCall<SubscribeOnRequest, BlockchainEvent>;
}
export interface BlockchainEventsServiceClient extends Client {
    subscribeOn(request: SubscribeOnRequest, options?: Partial<CallOptions>): ClientReadableStream<BlockchainEvent>;
    subscribeOn(request: SubscribeOnRequest, metadata?: Metadata, options?: Partial<CallOptions>): ClientReadableStream<BlockchainEvent>;
}
export declare const BlockchainEventsServiceClient: {
    new (address: string, credentials: ChannelCredentials, options?: Partial<ChannelOptions>): BlockchainEventsServiceClient;
    service: typeof BlockchainEventsServiceService;
};
