import Long from "long";
import { ChannelCredentials, ChannelOptions, UntypedServiceImplementation, handleUnaryCall, Client, ClientUnaryCall, Metadata, CallOptions, ServiceError } from "@grpc/grpc-js";
import * as _m0 from "protobufjs/minimal";
export declare const protobufPackage = "wavesenterprise.grpc";
export interface CertByDNRequest {
    dn?: string;
}
export interface CertByDNHashRequest {
    dnHash?: string;
}
export interface CertByPublicKeyRequest {
    publicKeyBase58?: string;
}
export interface CertByFingerprintRequest {
    fingerprintBase64?: string;
}
export interface CertificateResponse {
    certificate?: Uint8Array;
}
export declare const CertByDNRequest: {
    encode(message: CertByDNRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): CertByDNRequest;
    fromJSON(object: any): CertByDNRequest;
    toJSON(message: CertByDNRequest): unknown;
    fromPartial(object: DeepPartial<CertByDNRequest>): CertByDNRequest;
};
export declare const CertByDNHashRequest: {
    encode(message: CertByDNHashRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): CertByDNHashRequest;
    fromJSON(object: any): CertByDNHashRequest;
    toJSON(message: CertByDNHashRequest): unknown;
    fromPartial(object: DeepPartial<CertByDNHashRequest>): CertByDNHashRequest;
};
export declare const CertByPublicKeyRequest: {
    encode(message: CertByPublicKeyRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): CertByPublicKeyRequest;
    fromJSON(object: any): CertByPublicKeyRequest;
    toJSON(message: CertByPublicKeyRequest): unknown;
    fromPartial(object: DeepPartial<CertByPublicKeyRequest>): CertByPublicKeyRequest;
};
export declare const CertByFingerprintRequest: {
    encode(message: CertByFingerprintRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): CertByFingerprintRequest;
    fromJSON(object: any): CertByFingerprintRequest;
    toJSON(message: CertByFingerprintRequest): unknown;
    fromPartial(object: DeepPartial<CertByFingerprintRequest>): CertByFingerprintRequest;
};
export declare const CertificateResponse: {
    encode(message: CertificateResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): CertificateResponse;
    fromJSON(object: any): CertificateResponse;
    toJSON(message: CertificateResponse): unknown;
    fromPartial(object: DeepPartial<CertificateResponse>): CertificateResponse;
};
export declare const PkiPublicServiceService: {
    readonly getCertificateByDn: {
        readonly path: "/wavesenterprise.grpc.PkiPublicService/GetCertificateByDn";
        readonly requestStream: false;
        readonly responseStream: false;
        readonly requestSerialize: (value: CertByDNRequest) => Buffer;
        readonly requestDeserialize: (value: Buffer) => CertByDNRequest;
        readonly responseSerialize: (value: CertificateResponse) => Buffer;
        readonly responseDeserialize: (value: Buffer) => CertificateResponse;
    };
    readonly getCertificateByDnHash: {
        readonly path: "/wavesenterprise.grpc.PkiPublicService/GetCertificateByDnHash";
        readonly requestStream: false;
        readonly responseStream: false;
        readonly requestSerialize: (value: CertByDNHashRequest) => Buffer;
        readonly requestDeserialize: (value: Buffer) => CertByDNHashRequest;
        readonly responseSerialize: (value: CertificateResponse) => Buffer;
        readonly responseDeserialize: (value: Buffer) => CertificateResponse;
    };
    readonly getCertificateByPublicKey: {
        readonly path: "/wavesenterprise.grpc.PkiPublicService/GetCertificateByPublicKey";
        readonly requestStream: false;
        readonly responseStream: false;
        readonly requestSerialize: (value: CertByPublicKeyRequest) => Buffer;
        readonly requestDeserialize: (value: Buffer) => CertByPublicKeyRequest;
        readonly responseSerialize: (value: CertificateResponse) => Buffer;
        readonly responseDeserialize: (value: Buffer) => CertificateResponse;
    };
    readonly getCertificateByFingerprint: {
        readonly path: "/wavesenterprise.grpc.PkiPublicService/GetCertificateByFingerprint";
        readonly requestStream: false;
        readonly responseStream: false;
        readonly requestSerialize: (value: CertByFingerprintRequest) => Buffer;
        readonly requestDeserialize: (value: Buffer) => CertByFingerprintRequest;
        readonly responseSerialize: (value: CertificateResponse) => Buffer;
        readonly responseDeserialize: (value: Buffer) => CertificateResponse;
    };
};
export interface PkiPublicServiceServer extends UntypedServiceImplementation {
    getCertificateByDn: handleUnaryCall<CertByDNRequest, CertificateResponse>;
    getCertificateByDnHash: handleUnaryCall<CertByDNHashRequest, CertificateResponse>;
    getCertificateByPublicKey: handleUnaryCall<CertByPublicKeyRequest, CertificateResponse>;
    getCertificateByFingerprint: handleUnaryCall<CertByFingerprintRequest, CertificateResponse>;
}
export interface PkiPublicServiceClient extends Client {
    getCertificateByDn(request: CertByDNRequest, callback: (error: ServiceError | null, response: CertificateResponse) => void): ClientUnaryCall;
    getCertificateByDn(request: CertByDNRequest, metadata: Metadata, callback: (error: ServiceError | null, response: CertificateResponse) => void): ClientUnaryCall;
    getCertificateByDn(request: CertByDNRequest, metadata: Metadata, options: Partial<CallOptions>, callback: (error: ServiceError | null, response: CertificateResponse) => void): ClientUnaryCall;
    getCertificateByDnHash(request: CertByDNHashRequest, callback: (error: ServiceError | null, response: CertificateResponse) => void): ClientUnaryCall;
    getCertificateByDnHash(request: CertByDNHashRequest, metadata: Metadata, callback: (error: ServiceError | null, response: CertificateResponse) => void): ClientUnaryCall;
    getCertificateByDnHash(request: CertByDNHashRequest, metadata: Metadata, options: Partial<CallOptions>, callback: (error: ServiceError | null, response: CertificateResponse) => void): ClientUnaryCall;
    getCertificateByPublicKey(request: CertByPublicKeyRequest, callback: (error: ServiceError | null, response: CertificateResponse) => void): ClientUnaryCall;
    getCertificateByPublicKey(request: CertByPublicKeyRequest, metadata: Metadata, callback: (error: ServiceError | null, response: CertificateResponse) => void): ClientUnaryCall;
    getCertificateByPublicKey(request: CertByPublicKeyRequest, metadata: Metadata, options: Partial<CallOptions>, callback: (error: ServiceError | null, response: CertificateResponse) => void): ClientUnaryCall;
    getCertificateByFingerprint(request: CertByFingerprintRequest, callback: (error: ServiceError | null, response: CertificateResponse) => void): ClientUnaryCall;
    getCertificateByFingerprint(request: CertByFingerprintRequest, metadata: Metadata, callback: (error: ServiceError | null, response: CertificateResponse) => void): ClientUnaryCall;
    getCertificateByFingerprint(request: CertByFingerprintRequest, metadata: Metadata, options: Partial<CallOptions>, callback: (error: ServiceError | null, response: CertificateResponse) => void): ClientUnaryCall;
}
export declare const PkiPublicServiceClient: {
    new (address: string, credentials: ChannelCredentials, options?: Partial<ChannelOptions>): PkiPublicServiceClient;
    service: typeof PkiPublicServiceService;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
