import Long from "long";
import { ChannelCredentials, ChannelOptions, UntypedServiceImplementation, handleServerStreamingCall, Client, CallOptions, ClientReadableStream, Metadata } from "@grpc/grpc-js";
import * as _m0 from "protobufjs/minimal";
import { SubscribeOnRequest } from "../util/events/util_events_subscribe_on_request";
export declare const protobufPackage = "wavesenterprise";
export interface PrivacyEvent {
    policyId?: string;
    dataHash?: string;
    eventType?: PrivacyEvent_EventType;
}
export declare enum PrivacyEvent_EventType {
    DATA_ACQUIRED = 0,
    DATA_INVALIDATED = 1,
    UNRECOGNIZED = -1
}
export declare function privacyEvent_EventTypeFromJSON(object: any): PrivacyEvent_EventType;
export declare function privacyEvent_EventTypeToJSON(object: PrivacyEvent_EventType): string;
export declare const PrivacyEvent: {
    encode(message: PrivacyEvent, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): PrivacyEvent;
    fromJSON(object: any): PrivacyEvent;
    toJSON(message: PrivacyEvent): unknown;
    fromPartial(object: DeepPartial<PrivacyEvent>): PrivacyEvent;
};
export declare const PrivacyEventsServiceService: {
    readonly subscribeOn: {
        readonly path: "/wavesenterprise.PrivacyEventsService/SubscribeOn";
        readonly requestStream: false;
        readonly responseStream: true;
        readonly requestSerialize: (value: SubscribeOnRequest) => Buffer;
        readonly requestDeserialize: (value: Buffer) => SubscribeOnRequest;
        readonly responseSerialize: (value: PrivacyEvent) => Buffer;
        readonly responseDeserialize: (value: Buffer) => PrivacyEvent;
    };
};
export interface PrivacyEventsServiceServer extends UntypedServiceImplementation {
    subscribeOn: handleServerStreamingCall<SubscribeOnRequest, PrivacyEvent>;
}
export interface PrivacyEventsServiceClient extends Client {
    subscribeOn(request: SubscribeOnRequest, options?: Partial<CallOptions>): ClientReadableStream<PrivacyEvent>;
    subscribeOn(request: SubscribeOnRequest, metadata?: Metadata, options?: Partial<CallOptions>): ClientReadableStream<PrivacyEvent>;
}
export declare const PrivacyEventsServiceClient: {
    new (address: string, credentials: ChannelCredentials, options?: Partial<ChannelOptions>): PrivacyEventsServiceClient;
    service: typeof PrivacyEventsServiceService;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
