"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PrivacyEventsServiceClient = exports.PrivacyEventsServiceService = exports.PrivacyEvent = exports.privacyEvent_EventTypeToJSON = exports.privacyEvent_EventTypeFromJSON = exports.PrivacyEvent_EventType = exports.protobufPackage = void 0;
const long_1 = __importDefault(require("long"));
const grpc_js_1 = require("@grpc/grpc-js");
const _m0 = __importStar(require("protobufjs/minimal"));
const util_events_subscribe_on_request_1 = require("../util/events/util_events_subscribe_on_request");
exports.protobufPackage = "wavesenterprise";
var PrivacyEvent_EventType;
(function (PrivacyEvent_EventType) {
    PrivacyEvent_EventType[PrivacyEvent_EventType["DATA_ACQUIRED"] = 0] = "DATA_ACQUIRED";
    PrivacyEvent_EventType[PrivacyEvent_EventType["DATA_INVALIDATED"] = 1] = "DATA_INVALIDATED";
    PrivacyEvent_EventType[PrivacyEvent_EventType["UNRECOGNIZED"] = -1] = "UNRECOGNIZED";
})(PrivacyEvent_EventType = exports.PrivacyEvent_EventType || (exports.PrivacyEvent_EventType = {}));
function privacyEvent_EventTypeFromJSON(object) {
    switch (object) {
        case 0:
        case "DATA_ACQUIRED":
            return PrivacyEvent_EventType.DATA_ACQUIRED;
        case 1:
        case "DATA_INVALIDATED":
            return PrivacyEvent_EventType.DATA_INVALIDATED;
        case -1:
        case "UNRECOGNIZED":
        default:
            return PrivacyEvent_EventType.UNRECOGNIZED;
    }
}
exports.privacyEvent_EventTypeFromJSON = privacyEvent_EventTypeFromJSON;
function privacyEvent_EventTypeToJSON(object) {
    switch (object) {
        case PrivacyEvent_EventType.DATA_ACQUIRED:
            return "DATA_ACQUIRED";
        case PrivacyEvent_EventType.DATA_INVALIDATED:
            return "DATA_INVALIDATED";
        default:
            return "UNKNOWN";
    }
}
exports.privacyEvent_EventTypeToJSON = privacyEvent_EventTypeToJSON;
function createBasePrivacyEvent() {
    return { policyId: "", dataHash: "", eventType: 0 };
}
exports.PrivacyEvent = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.policyId !== undefined && message.policyId !== "") {
            writer.uint32(10).string(message.policyId);
        }
        if (message.dataHash !== undefined && message.dataHash !== "") {
            writer.uint32(18).string(message.dataHash);
        }
        if (message.eventType !== undefined && message.eventType !== 0) {
            writer.uint32(24).int32(message.eventType);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBasePrivacyEvent();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.policyId = reader.string();
                    break;
                case 2:
                    message.dataHash = reader.string();
                    break;
                case 3:
                    message.eventType = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            policyId: isSet(object.policyId) ? String(object.policyId) : "",
            dataHash: isSet(object.dataHash) ? String(object.dataHash) : "",
            eventType: isSet(object.eventType)
                ? privacyEvent_EventTypeFromJSON(object.eventType)
                : 0,
        };
    },
    toJSON(message) {
        const obj = {};
        message.policyId !== undefined && (obj.policyId = message.policyId);
        message.dataHash !== undefined && (obj.dataHash = message.dataHash);
        message.eventType !== undefined &&
            (obj.eventType = privacyEvent_EventTypeToJSON(message.eventType));
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c;
        const message = createBasePrivacyEvent();
        message.policyId = (_a = object.policyId) !== null && _a !== void 0 ? _a : "";
        message.dataHash = (_b = object.dataHash) !== null && _b !== void 0 ? _b : "";
        message.eventType = (_c = object.eventType) !== null && _c !== void 0 ? _c : 0;
        return message;
    },
};
exports.PrivacyEventsServiceService = {
    subscribeOn: {
        path: "/wavesenterprise.PrivacyEventsService/SubscribeOn",
        requestStream: false,
        responseStream: true,
        requestSerialize: (value) => Buffer.from(util_events_subscribe_on_request_1.SubscribeOnRequest.encode(value).finish()),
        requestDeserialize: (value) => util_events_subscribe_on_request_1.SubscribeOnRequest.decode(value),
        responseSerialize: (value) => Buffer.from(exports.PrivacyEvent.encode(value).finish()),
        responseDeserialize: (value) => exports.PrivacyEvent.decode(value),
    },
};
exports.PrivacyEventsServiceClient = (0, grpc_js_1.makeGenericClientConstructor)(exports.PrivacyEventsServiceService, "wavesenterprise.PrivacyEventsService");
if (_m0.util.Long !== long_1.default) {
    _m0.util.Long = long_1.default;
    _m0.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
//# sourceMappingURL=privacy_events_service.js.map