import Long from "long";
import { ChannelCredentials, ChannelOptions, UntypedServiceImplementation, handleUnaryCall, handleServerStreamingCall, handleClientStreamingCall, Client, ClientUnaryCall, Metadata, CallOptions, ClientReadableStream, ClientWritableStream, ServiceError } from "@grpc/grpc-js";
import * as _m0 from "protobufjs/minimal";
import { PolicyDataHashTransaction } from "../managed/policy_data_hash_transaction";
import { AtomicBadge } from "../atomic_badge";
import { AddressesResponse } from "../entity/address";
export declare const protobufPackage = "wavesenterprise.grpc";
export interface PolicyItemRequest {
    policyId?: string;
    dataHash?: string;
}
export interface PolicyItemDataResponse {
    data?: Uint8Array;
}
export interface PolicyItemInfoResponse {
    senderAddress?: string;
    policyId?: string;
    info?: PolicyItemFileInfo;
    dataHash?: string;
}
export interface PolicyItemDataExistsResponse {
    exists?: boolean;
}
export interface PolicyItemFileInfo {
    filename?: string;
    size?: number;
    timestamp?: Long;
    author?: string;
    comment?: string;
}
export interface SendDataResponse {
    txVersion?: number;
    tx?: PolicyDataHashTransaction;
}
export interface SendDataRequest {
    metadata?: SendDataMetadata;
    data?: Uint8Array;
}
export interface SendLargeDataRequest {
    metadata?: SendDataMetadata | undefined;
    file?: File | undefined;
}
export interface File {
    content?: Uint8Array;
}
export interface SendDataMetadata {
    senderAddress?: string;
    policyId?: string;
    dataHash?: string;
    info?: PolicyItemFileInfo;
    fee?: Long;
    feeAssetId?: string;
    atomicBadge?: AtomicBadge;
    password?: string;
    broadcastTx?: boolean;
    certificates?: Uint8Array[];
}
export interface PolicyIdRequest {
    policyId?: string;
}
export interface HashesResponse {
    hashes?: string[];
}
export interface ForceSyncResponse {
    forceRestarted?: number;
}
export declare const PolicyItemRequest: {
    encode(message: PolicyItemRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): PolicyItemRequest;
    fromJSON(object: any): PolicyItemRequest;
    toJSON(message: PolicyItemRequest): unknown;
    fromPartial(object: DeepPartial<PolicyItemRequest>): PolicyItemRequest;
};
export declare const PolicyItemDataResponse: {
    encode(message: PolicyItemDataResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): PolicyItemDataResponse;
    fromJSON(object: any): PolicyItemDataResponse;
    toJSON(message: PolicyItemDataResponse): unknown;
    fromPartial(object: DeepPartial<PolicyItemDataResponse>): PolicyItemDataResponse;
};
export declare const PolicyItemInfoResponse: {
    encode(message: PolicyItemInfoResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): PolicyItemInfoResponse;
    fromJSON(object: any): PolicyItemInfoResponse;
    toJSON(message: PolicyItemInfoResponse): unknown;
    fromPartial(object: DeepPartial<PolicyItemInfoResponse>): PolicyItemInfoResponse;
};
export declare const PolicyItemDataExistsResponse: {
    encode(message: PolicyItemDataExistsResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): PolicyItemDataExistsResponse;
    fromJSON(object: any): PolicyItemDataExistsResponse;
    toJSON(message: PolicyItemDataExistsResponse): unknown;
    fromPartial(object: DeepPartial<PolicyItemDataExistsResponse>): PolicyItemDataExistsResponse;
};
export declare const PolicyItemFileInfo: {
    encode(message: PolicyItemFileInfo, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): PolicyItemFileInfo;
    fromJSON(object: any): PolicyItemFileInfo;
    toJSON(message: PolicyItemFileInfo): unknown;
    fromPartial(object: DeepPartial<PolicyItemFileInfo>): PolicyItemFileInfo;
};
export declare const SendDataResponse: {
    encode(message: SendDataResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): SendDataResponse;
    fromJSON(object: any): SendDataResponse;
    toJSON(message: SendDataResponse): unknown;
    fromPartial(object: DeepPartial<SendDataResponse>): SendDataResponse;
};
export declare const SendDataRequest: {
    encode(message: SendDataRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): SendDataRequest;
    fromJSON(object: any): SendDataRequest;
    toJSON(message: SendDataRequest): unknown;
    fromPartial(object: DeepPartial<SendDataRequest>): SendDataRequest;
};
export declare const SendLargeDataRequest: {
    encode(message: SendLargeDataRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): SendLargeDataRequest;
    fromJSON(object: any): SendLargeDataRequest;
    toJSON(message: SendLargeDataRequest): unknown;
    fromPartial(object: DeepPartial<SendLargeDataRequest>): SendLargeDataRequest;
};
export declare const File: {
    encode(message: File, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): File;
    fromJSON(object: any): File;
    toJSON(message: File): unknown;
    fromPartial(object: DeepPartial<File>): File;
};
export declare const SendDataMetadata: {
    encode(message: SendDataMetadata, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): SendDataMetadata;
    fromJSON(object: any): SendDataMetadata;
    toJSON(message: SendDataMetadata): unknown;
    fromPartial(object: DeepPartial<SendDataMetadata>): SendDataMetadata;
};
export declare const PolicyIdRequest: {
    encode(message: PolicyIdRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): PolicyIdRequest;
    fromJSON(object: any): PolicyIdRequest;
    toJSON(message: PolicyIdRequest): unknown;
    fromPartial(object: DeepPartial<PolicyIdRequest>): PolicyIdRequest;
};
export declare const HashesResponse: {
    encode(message: HashesResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): HashesResponse;
    fromJSON(object: any): HashesResponse;
    toJSON(message: HashesResponse): unknown;
    fromPartial(object: DeepPartial<HashesResponse>): HashesResponse;
};
export declare const ForceSyncResponse: {
    encode(message: ForceSyncResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): ForceSyncResponse;
    fromJSON(object: any): ForceSyncResponse;
    toJSON(message: ForceSyncResponse): unknown;
    fromPartial(object: DeepPartial<ForceSyncResponse>): ForceSyncResponse;
};
export declare const PrivacyPublicServiceService: {
    readonly getPolicyItemData: {
        readonly path: "/wavesenterprise.grpc.PrivacyPublicService/GetPolicyItemData";
        readonly requestStream: false;
        readonly responseStream: false;
        readonly requestSerialize: (value: PolicyItemRequest) => Buffer;
        readonly requestDeserialize: (value: Buffer) => PolicyItemRequest;
        readonly responseSerialize: (value: PolicyItemDataResponse) => Buffer;
        readonly responseDeserialize: (value: Buffer) => PolicyItemDataResponse;
    };
    readonly getPolicyItemLargeData: {
        readonly path: "/wavesenterprise.grpc.PrivacyPublicService/GetPolicyItemLargeData";
        readonly requestStream: false;
        readonly responseStream: true;
        readonly requestSerialize: (value: PolicyItemRequest) => Buffer;
        readonly requestDeserialize: (value: Buffer) => PolicyItemRequest;
        readonly responseSerialize: (value: PolicyItemDataResponse) => Buffer;
        readonly responseDeserialize: (value: Buffer) => PolicyItemDataResponse;
    };
    readonly getPolicyItemInfo: {
        readonly path: "/wavesenterprise.grpc.PrivacyPublicService/GetPolicyItemInfo";
        readonly requestStream: false;
        readonly responseStream: false;
        readonly requestSerialize: (value: PolicyItemRequest) => Buffer;
        readonly requestDeserialize: (value: Buffer) => PolicyItemRequest;
        readonly responseSerialize: (value: PolicyItemInfoResponse) => Buffer;
        readonly responseDeserialize: (value: Buffer) => PolicyItemInfoResponse;
    };
    readonly policyItemDataExists: {
        readonly path: "/wavesenterprise.grpc.PrivacyPublicService/PolicyItemDataExists";
        readonly requestStream: false;
        readonly responseStream: false;
        readonly requestSerialize: (value: PolicyItemRequest) => Buffer;
        readonly requestDeserialize: (value: Buffer) => PolicyItemRequest;
        readonly responseSerialize: (value: PolicyItemDataExistsResponse) => Buffer;
        readonly responseDeserialize: (value: Buffer) => PolicyItemDataExistsResponse;
    };
    readonly sendData: {
        readonly path: "/wavesenterprise.grpc.PrivacyPublicService/SendData";
        readonly requestStream: false;
        readonly responseStream: false;
        readonly requestSerialize: (value: SendDataRequest) => Buffer;
        readonly requestDeserialize: (value: Buffer) => SendDataRequest;
        readonly responseSerialize: (value: SendDataResponse) => Buffer;
        readonly responseDeserialize: (value: Buffer) => SendDataResponse;
    };
    readonly sendLargeData: {
        readonly path: "/wavesenterprise.grpc.PrivacyPublicService/SendLargeData";
        readonly requestStream: true;
        readonly responseStream: false;
        readonly requestSerialize: (value: SendLargeDataRequest) => Buffer;
        readonly requestDeserialize: (value: Buffer) => SendLargeDataRequest;
        readonly responseSerialize: (value: SendDataResponse) => Buffer;
        readonly responseDeserialize: (value: Buffer) => SendDataResponse;
    };
    readonly recipients: {
        readonly path: "/wavesenterprise.grpc.PrivacyPublicService/Recipients";
        readonly requestStream: false;
        readonly responseStream: false;
        readonly requestSerialize: (value: PolicyIdRequest) => Buffer;
        readonly requestDeserialize: (value: Buffer) => PolicyIdRequest;
        readonly responseSerialize: (value: AddressesResponse) => Buffer;
        readonly responseDeserialize: (value: Buffer) => AddressesResponse;
    };
    readonly owners: {
        readonly path: "/wavesenterprise.grpc.PrivacyPublicService/Owners";
        readonly requestStream: false;
        readonly responseStream: false;
        readonly requestSerialize: (value: PolicyIdRequest) => Buffer;
        readonly requestDeserialize: (value: Buffer) => PolicyIdRequest;
        readonly responseSerialize: (value: AddressesResponse) => Buffer;
        readonly responseDeserialize: (value: Buffer) => AddressesResponse;
    };
    readonly hashes: {
        readonly path: "/wavesenterprise.grpc.PrivacyPublicService/Hashes";
        readonly requestStream: false;
        readonly responseStream: false;
        readonly requestSerialize: (value: PolicyIdRequest) => Buffer;
        readonly requestDeserialize: (value: Buffer) => PolicyIdRequest;
        readonly responseSerialize: (value: HashesResponse) => Buffer;
        readonly responseDeserialize: (value: Buffer) => HashesResponse;
    };
    readonly forceSync: {
        readonly path: "/wavesenterprise.grpc.PrivacyPublicService/ForceSync";
        readonly requestStream: false;
        readonly responseStream: false;
        readonly requestSerialize: (value: PolicyIdRequest) => Buffer;
        readonly requestDeserialize: (value: Buffer) => PolicyIdRequest;
        readonly responseSerialize: (value: ForceSyncResponse) => Buffer;
        readonly responseDeserialize: (value: Buffer) => ForceSyncResponse;
    };
};
export interface PrivacyPublicServiceServer extends UntypedServiceImplementation {
    getPolicyItemData: handleUnaryCall<PolicyItemRequest, PolicyItemDataResponse>;
    getPolicyItemLargeData: handleServerStreamingCall<PolicyItemRequest, PolicyItemDataResponse>;
    getPolicyItemInfo: handleUnaryCall<PolicyItemRequest, PolicyItemInfoResponse>;
    policyItemDataExists: handleUnaryCall<PolicyItemRequest, PolicyItemDataExistsResponse>;
    sendData: handleUnaryCall<SendDataRequest, SendDataResponse>;
    sendLargeData: handleClientStreamingCall<SendLargeDataRequest, SendDataResponse>;
    recipients: handleUnaryCall<PolicyIdRequest, AddressesResponse>;
    owners: handleUnaryCall<PolicyIdRequest, AddressesResponse>;
    hashes: handleUnaryCall<PolicyIdRequest, HashesResponse>;
    forceSync: handleUnaryCall<PolicyIdRequest, ForceSyncResponse>;
}
export interface PrivacyPublicServiceClient extends Client {
    getPolicyItemData(request: PolicyItemRequest, callback: (error: ServiceError | null, response: PolicyItemDataResponse) => void): ClientUnaryCall;
    getPolicyItemData(request: PolicyItemRequest, metadata: Metadata, callback: (error: ServiceError | null, response: PolicyItemDataResponse) => void): ClientUnaryCall;
    getPolicyItemData(request: PolicyItemRequest, metadata: Metadata, options: Partial<CallOptions>, callback: (error: ServiceError | null, response: PolicyItemDataResponse) => void): ClientUnaryCall;
    getPolicyItemLargeData(request: PolicyItemRequest, options?: Partial<CallOptions>): ClientReadableStream<PolicyItemDataResponse>;
    getPolicyItemLargeData(request: PolicyItemRequest, metadata?: Metadata, options?: Partial<CallOptions>): ClientReadableStream<PolicyItemDataResponse>;
    getPolicyItemInfo(request: PolicyItemRequest, callback: (error: ServiceError | null, response: PolicyItemInfoResponse) => void): ClientUnaryCall;
    getPolicyItemInfo(request: PolicyItemRequest, metadata: Metadata, callback: (error: ServiceError | null, response: PolicyItemInfoResponse) => void): ClientUnaryCall;
    getPolicyItemInfo(request: PolicyItemRequest, metadata: Metadata, options: Partial<CallOptions>, callback: (error: ServiceError | null, response: PolicyItemInfoResponse) => void): ClientUnaryCall;
    policyItemDataExists(request: PolicyItemRequest, callback: (error: ServiceError | null, response: PolicyItemDataExistsResponse) => void): ClientUnaryCall;
    policyItemDataExists(request: PolicyItemRequest, metadata: Metadata, callback: (error: ServiceError | null, response: PolicyItemDataExistsResponse) => void): ClientUnaryCall;
    policyItemDataExists(request: PolicyItemRequest, metadata: Metadata, options: Partial<CallOptions>, callback: (error: ServiceError | null, response: PolicyItemDataExistsResponse) => void): ClientUnaryCall;
    sendData(request: SendDataRequest, callback: (error: ServiceError | null, response: SendDataResponse) => void): ClientUnaryCall;
    sendData(request: SendDataRequest, metadata: Metadata, callback: (error: ServiceError | null, response: SendDataResponse) => void): ClientUnaryCall;
    sendData(request: SendDataRequest, metadata: Metadata, options: Partial<CallOptions>, callback: (error: ServiceError | null, response: SendDataResponse) => void): ClientUnaryCall;
    sendLargeData(callback: (error: ServiceError | null, response: SendDataResponse) => void): ClientWritableStream<SendLargeDataRequest>;
    sendLargeData(metadata: Metadata, callback: (error: ServiceError | null, response: SendDataResponse) => void): ClientWritableStream<SendLargeDataRequest>;
    sendLargeData(options: Partial<CallOptions>, callback: (error: ServiceError | null, response: SendDataResponse) => void): ClientWritableStream<SendLargeDataRequest>;
    sendLargeData(metadata: Metadata, options: Partial<CallOptions>, callback: (error: ServiceError | null, response: SendDataResponse) => void): ClientWritableStream<SendLargeDataRequest>;
    recipients(request: PolicyIdRequest, callback: (error: ServiceError | null, response: AddressesResponse) => void): ClientUnaryCall;
    recipients(request: PolicyIdRequest, metadata: Metadata, callback: (error: ServiceError | null, response: AddressesResponse) => void): ClientUnaryCall;
    recipients(request: PolicyIdRequest, metadata: Metadata, options: Partial<CallOptions>, callback: (error: ServiceError | null, response: AddressesResponse) => void): ClientUnaryCall;
    owners(request: PolicyIdRequest, callback: (error: ServiceError | null, response: AddressesResponse) => void): ClientUnaryCall;
    owners(request: PolicyIdRequest, metadata: Metadata, callback: (error: ServiceError | null, response: AddressesResponse) => void): ClientUnaryCall;
    owners(request: PolicyIdRequest, metadata: Metadata, options: Partial<CallOptions>, callback: (error: ServiceError | null, response: AddressesResponse) => void): ClientUnaryCall;
    hashes(request: PolicyIdRequest, callback: (error: ServiceError | null, response: HashesResponse) => void): ClientUnaryCall;
    hashes(request: PolicyIdRequest, metadata: Metadata, callback: (error: ServiceError | null, response: HashesResponse) => void): ClientUnaryCall;
    hashes(request: PolicyIdRequest, metadata: Metadata, options: Partial<CallOptions>, callback: (error: ServiceError | null, response: HashesResponse) => void): ClientUnaryCall;
    forceSync(request: PolicyIdRequest, callback: (error: ServiceError | null, response: ForceSyncResponse) => void): ClientUnaryCall;
    forceSync(request: PolicyIdRequest, metadata: Metadata, callback: (error: ServiceError | null, response: ForceSyncResponse) => void): ClientUnaryCall;
    forceSync(request: PolicyIdRequest, metadata: Metadata, options: Partial<CallOptions>, callback: (error: ServiceError | null, response: ForceSyncResponse) => void): ClientUnaryCall;
}
export declare const PrivacyPublicServiceClient: {
    new (address: string, credentials: ChannelCredentials, options?: Partial<ChannelOptions>): PrivacyPublicServiceClient;
    service: typeof PrivacyPublicServiceService;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
