import Long from "long";
import { ChannelCredentials, ChannelOptions, UntypedServiceImplementation, handleUnaryCall, handleServerStreamingCall, Client, ClientUnaryCall, Metadata, CallOptions, ClientReadableStream, ServiceError } from "@grpc/grpc-js";
import * as _m0 from "protobufjs/minimal";
import { Transaction } from "../managed/transaction";
import { TransactionWithCertChain, TransactionInfoRequest, TransactionInfoResponse } from "../util/util_transaction_service";
import { Empty } from "../google/protobuf/empty";
export declare const protobufPackage = "wavesenterprise.grpc";
export interface UtxSize {
    size?: number;
    sizeInBytes?: Long;
}
export declare const UtxSize: {
    encode(message: UtxSize, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): UtxSize;
    fromJSON(object: any): UtxSize;
    toJSON(message: UtxSize): unknown;
    fromPartial(object: DeepPartial<UtxSize>): UtxSize;
};
export declare const TransactionPublicServiceService: {
    readonly broadcast: {
        readonly path: "/wavesenterprise.grpc.TransactionPublicService/Broadcast";
        readonly requestStream: false;
        readonly responseStream: false;
        readonly requestSerialize: (value: Transaction) => Buffer;
        readonly requestDeserialize: (value: Buffer) => Transaction;
        readonly responseSerialize: (value: Transaction) => Buffer;
        readonly responseDeserialize: (value: Buffer) => Transaction;
    };
    readonly broadcastWithCerts: {
        readonly path: "/wavesenterprise.grpc.TransactionPublicService/BroadcastWithCerts";
        readonly requestStream: false;
        readonly responseStream: false;
        readonly requestSerialize: (value: TransactionWithCertChain) => Buffer;
        readonly requestDeserialize: (value: Buffer) => TransactionWithCertChain;
        readonly responseSerialize: (value: Transaction) => Buffer;
        readonly responseDeserialize: (value: Buffer) => Transaction;
    };
    readonly utxInfo: {
        readonly path: "/wavesenterprise.grpc.TransactionPublicService/UtxInfo";
        readonly requestStream: false;
        readonly responseStream: true;
        readonly requestSerialize: (value: Empty) => Buffer;
        readonly requestDeserialize: (value: Buffer) => Empty;
        readonly responseSerialize: (value: UtxSize) => Buffer;
        readonly responseDeserialize: (value: Buffer) => UtxSize;
    };
    readonly transactionInfo: {
        readonly path: "/wavesenterprise.grpc.TransactionPublicService/TransactionInfo";
        readonly requestStream: false;
        readonly responseStream: false;
        readonly requestSerialize: (value: TransactionInfoRequest) => Buffer;
        readonly requestDeserialize: (value: Buffer) => TransactionInfoRequest;
        readonly responseSerialize: (value: TransactionInfoResponse) => Buffer;
        readonly responseDeserialize: (value: Buffer) => TransactionInfoResponse;
    };
    readonly unconfirmedTransactionInfo: {
        readonly path: "/wavesenterprise.grpc.TransactionPublicService/UnconfirmedTransactionInfo";
        readonly requestStream: false;
        readonly responseStream: false;
        readonly requestSerialize: (value: TransactionInfoRequest) => Buffer;
        readonly requestDeserialize: (value: Buffer) => TransactionInfoRequest;
        readonly responseSerialize: (value: Transaction) => Buffer;
        readonly responseDeserialize: (value: Buffer) => Transaction;
    };
};
export interface TransactionPublicServiceServer extends UntypedServiceImplementation {
    broadcast: handleUnaryCall<Transaction, Transaction>;
    broadcastWithCerts: handleUnaryCall<TransactionWithCertChain, Transaction>;
    utxInfo: handleServerStreamingCall<Empty, UtxSize>;
    transactionInfo: handleUnaryCall<TransactionInfoRequest, TransactionInfoResponse>;
    unconfirmedTransactionInfo: handleUnaryCall<TransactionInfoRequest, Transaction>;
}
export interface TransactionPublicServiceClient extends Client {
    broadcast(request: Transaction, callback: (error: ServiceError | null, response: Transaction) => void): ClientUnaryCall;
    broadcast(request: Transaction, metadata: Metadata, callback: (error: ServiceError | null, response: Transaction) => void): ClientUnaryCall;
    broadcast(request: Transaction, metadata: Metadata, options: Partial<CallOptions>, callback: (error: ServiceError | null, response: Transaction) => void): ClientUnaryCall;
    broadcastWithCerts(request: TransactionWithCertChain, callback: (error: ServiceError | null, response: Transaction) => void): ClientUnaryCall;
    broadcastWithCerts(request: TransactionWithCertChain, metadata: Metadata, callback: (error: ServiceError | null, response: Transaction) => void): ClientUnaryCall;
    broadcastWithCerts(request: TransactionWithCertChain, metadata: Metadata, options: Partial<CallOptions>, callback: (error: ServiceError | null, response: Transaction) => void): ClientUnaryCall;
    utxInfo(request: Empty, options?: Partial<CallOptions>): ClientReadableStream<UtxSize>;
    utxInfo(request: Empty, metadata?: Metadata, options?: Partial<CallOptions>): ClientReadableStream<UtxSize>;
    transactionInfo(request: TransactionInfoRequest, callback: (error: ServiceError | null, response: TransactionInfoResponse) => void): ClientUnaryCall;
    transactionInfo(request: TransactionInfoRequest, metadata: Metadata, callback: (error: ServiceError | null, response: TransactionInfoResponse) => void): ClientUnaryCall;
    transactionInfo(request: TransactionInfoRequest, metadata: Metadata, options: Partial<CallOptions>, callback: (error: ServiceError | null, response: TransactionInfoResponse) => void): ClientUnaryCall;
    unconfirmedTransactionInfo(request: TransactionInfoRequest, callback: (error: ServiceError | null, response: Transaction) => void): ClientUnaryCall;
    unconfirmedTransactionInfo(request: TransactionInfoRequest, metadata: Metadata, callback: (error: ServiceError | null, response: Transaction) => void): ClientUnaryCall;
    unconfirmedTransactionInfo(request: TransactionInfoRequest, metadata: Metadata, options: Partial<CallOptions>, callback: (error: ServiceError | null, response: Transaction) => void): ClientUnaryCall;
}
export declare const TransactionPublicServiceClient: {
    new (address: string, credentials: ChannelCredentials, options?: Partial<ChannelOptions>): TransactionPublicServiceClient;
    service: typeof TransactionPublicServiceService;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
