"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TransactionPublicServiceClient = exports.TransactionPublicServiceService = exports.UtxSize = exports.protobufPackage = void 0;
const long_1 = __importDefault(require("long"));
const grpc_js_1 = require("@grpc/grpc-js");
const _m0 = __importStar(require("protobufjs/minimal"));
const transaction_1 = require("../managed/transaction");
const util_transaction_service_1 = require("../util/util_transaction_service");
const empty_1 = require("../google/protobuf/empty");
exports.protobufPackage = "wavesenterprise.grpc";
function createBaseUtxSize() {
    return { size: 0, sizeInBytes: long_1.default.ZERO };
}
exports.UtxSize = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.size !== undefined && message.size !== 0) {
            writer.uint32(8).int32(message.size);
        }
        if (message.sizeInBytes !== undefined && !message.sizeInBytes.isZero()) {
            writer.uint32(16).int64(message.sizeInBytes);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseUtxSize();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.size = reader.int32();
                    break;
                case 2:
                    message.sizeInBytes = reader.int64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            size: isSet(object.size) ? Number(object.size) : 0,
            sizeInBytes: isSet(object.sizeInBytes)
                ? long_1.default.fromString(object.sizeInBytes)
                : long_1.default.ZERO,
        };
    },
    toJSON(message) {
        const obj = {};
        message.size !== undefined && (obj.size = Math.round(message.size));
        message.sizeInBytes !== undefined &&
            (obj.sizeInBytes = (message.sizeInBytes || long_1.default.ZERO).toString());
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseUtxSize();
        message.size = (_a = object.size) !== null && _a !== void 0 ? _a : 0;
        message.sizeInBytes =
            object.sizeInBytes !== undefined && object.sizeInBytes !== null
                ? long_1.default.fromValue(object.sizeInBytes)
                : long_1.default.ZERO;
        return message;
    },
};
exports.TransactionPublicServiceService = {
    broadcast: {
        path: "/wavesenterprise.grpc.TransactionPublicService/Broadcast",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(transaction_1.Transaction.encode(value).finish()),
        requestDeserialize: (value) => transaction_1.Transaction.decode(value),
        responseSerialize: (value) => Buffer.from(transaction_1.Transaction.encode(value).finish()),
        responseDeserialize: (value) => transaction_1.Transaction.decode(value),
    },
    broadcastWithCerts: {
        path: "/wavesenterprise.grpc.TransactionPublicService/BroadcastWithCerts",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(util_transaction_service_1.TransactionWithCertChain.encode(value).finish()),
        requestDeserialize: (value) => util_transaction_service_1.TransactionWithCertChain.decode(value),
        responseSerialize: (value) => Buffer.from(transaction_1.Transaction.encode(value).finish()),
        responseDeserialize: (value) => transaction_1.Transaction.decode(value),
    },
    utxInfo: {
        path: "/wavesenterprise.grpc.TransactionPublicService/UtxInfo",
        requestStream: false,
        responseStream: true,
        requestSerialize: (value) => Buffer.from(empty_1.Empty.encode(value).finish()),
        requestDeserialize: (value) => empty_1.Empty.decode(value),
        responseSerialize: (value) => Buffer.from(exports.UtxSize.encode(value).finish()),
        responseDeserialize: (value) => exports.UtxSize.decode(value),
    },
    transactionInfo: {
        path: "/wavesenterprise.grpc.TransactionPublicService/TransactionInfo",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(util_transaction_service_1.TransactionInfoRequest.encode(value).finish()),
        requestDeserialize: (value) => util_transaction_service_1.TransactionInfoRequest.decode(value),
        responseSerialize: (value) => Buffer.from(util_transaction_service_1.TransactionInfoResponse.encode(value).finish()),
        responseDeserialize: (value) => util_transaction_service_1.TransactionInfoResponse.decode(value),
    },
    unconfirmedTransactionInfo: {
        path: "/wavesenterprise.grpc.TransactionPublicService/UnconfirmedTransactionInfo",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(util_transaction_service_1.TransactionInfoRequest.encode(value).finish()),
        requestDeserialize: (value) => util_transaction_service_1.TransactionInfoRequest.decode(value),
        responseSerialize: (value) => Buffer.from(transaction_1.Transaction.encode(value).finish()),
        responseDeserialize: (value) => transaction_1.Transaction.decode(value),
    },
};
exports.TransactionPublicServiceClient = (0, grpc_js_1.makeGenericClientConstructor)(exports.TransactionPublicServiceService, "wavesenterprise.grpc.TransactionPublicService");
if (_m0.util.Long !== long_1.default) {
    _m0.util.Long = long_1.default;
    _m0.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
//# sourceMappingURL=transaction_public_service.js.map