import Long from "long";
import { ChannelCredentials, ChannelOptions, UntypedServiceImplementation, handleServerStreamingCall, Client, CallOptions, ClientReadableStream, Metadata } from "@grpc/grpc-js";
import * as _m0 from "protobufjs/minimal";
import { Empty } from "../google/protobuf/empty";
export declare const protobufPackage = "wavesenterprise";
export interface ContractExecutionRequest {
    txId?: string;
}
export interface ContractExecutionResponse {
    sender?: string;
    txId?: string;
    status?: ContractExecutionResponse_Status;
    code?: number;
    message?: string;
    timestamp?: Long;
    signature?: string;
    senderAddress?: string;
    senderPublicKey?: string;
}
export declare enum ContractExecutionResponse_Status {
    SUCCESS = 0,
    ERROR = 1,
    FAILURE = 2,
    UNRECOGNIZED = -1
}
export declare function contractExecutionResponse_StatusFromJSON(object: any): ContractExecutionResponse_Status;
export declare function contractExecutionResponse_StatusToJSON(object: ContractExecutionResponse_Status): string;
export declare const ContractExecutionRequest: {
    encode(message: ContractExecutionRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): ContractExecutionRequest;
    fromJSON(object: any): ContractExecutionRequest;
    toJSON(message: ContractExecutionRequest): unknown;
    fromPartial(object: DeepPartial<ContractExecutionRequest>): ContractExecutionRequest;
};
export declare const ContractExecutionResponse: {
    encode(message: ContractExecutionResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): ContractExecutionResponse;
    fromJSON(object: any): ContractExecutionResponse;
    toJSON(message: ContractExecutionResponse): unknown;
    fromPartial(object: DeepPartial<ContractExecutionResponse>): ContractExecutionResponse;
};
export declare const ContractStatusServiceService: {
    readonly contractExecutionStatuses: {
        readonly path: "/wavesenterprise.ContractStatusService/ContractExecutionStatuses";
        readonly requestStream: false;
        readonly responseStream: true;
        readonly requestSerialize: (value: ContractExecutionRequest) => Buffer;
        readonly requestDeserialize: (value: Buffer) => ContractExecutionRequest;
        readonly responseSerialize: (value: ContractExecutionResponse) => Buffer;
        readonly responseDeserialize: (value: Buffer) => ContractExecutionResponse;
    };
    readonly contractsExecutionEvents: {
        readonly path: "/wavesenterprise.ContractStatusService/ContractsExecutionEvents";
        readonly requestStream: false;
        readonly responseStream: true;
        readonly requestSerialize: (value: Empty) => Buffer;
        readonly requestDeserialize: (value: Buffer) => Empty;
        readonly responseSerialize: (value: ContractExecutionResponse) => Buffer;
        readonly responseDeserialize: (value: Buffer) => ContractExecutionResponse;
    };
};
export interface ContractStatusServiceServer extends UntypedServiceImplementation {
    contractExecutionStatuses: handleServerStreamingCall<ContractExecutionRequest, ContractExecutionResponse>;
    contractsExecutionEvents: handleServerStreamingCall<Empty, ContractExecutionResponse>;
}
export interface ContractStatusServiceClient extends Client {
    contractExecutionStatuses(request: ContractExecutionRequest, options?: Partial<CallOptions>): ClientReadableStream<ContractExecutionResponse>;
    contractExecutionStatuses(request: ContractExecutionRequest, metadata?: Metadata, options?: Partial<CallOptions>): ClientReadableStream<ContractExecutionResponse>;
    contractsExecutionEvents(request: Empty, options?: Partial<CallOptions>): ClientReadableStream<ContractExecutionResponse>;
    contractsExecutionEvents(request: Empty, metadata?: Metadata, options?: Partial<CallOptions>): ClientReadableStream<ContractExecutionResponse>;
}
export declare const ContractStatusServiceClient: {
    new (address: string, credentials: ChannelCredentials, options?: Partial<ChannelOptions>): ContractStatusServiceClient;
    service: typeof ContractStatusServiceService;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
