import Long from "long";
import { ChannelCredentials, ChannelOptions, UntypedServiceImplementation, handleUnaryCall, Client, ClientUnaryCall, Metadata, CallOptions, ServiceError } from "@grpc/grpc-js";
import * as _m0 from "protobufjs/minimal";
import { Empty } from "../google/protobuf/empty";
export declare const protobufPackage = "wavesenterprise.grpc";
export interface NodeTimeResponse {
    system?: Long;
    ntp?: Long;
}
export declare const NodeTimeResponse: {
    encode(message: NodeTimeResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): NodeTimeResponse;
    fromJSON(object: any): NodeTimeResponse;
    toJSON(message: NodeTimeResponse): unknown;
    fromPartial(object: DeepPartial<NodeTimeResponse>): NodeTimeResponse;
};
export declare const UtilPublicServiceService: {
    readonly getNodeTime: {
        readonly path: "/wavesenterprise.grpc.UtilPublicService/GetNodeTime";
        readonly requestStream: false;
        readonly responseStream: false;
        readonly requestSerialize: (value: Empty) => Buffer;
        readonly requestDeserialize: (value: Buffer) => Empty;
        readonly responseSerialize: (value: NodeTimeResponse) => Buffer;
        readonly responseDeserialize: (value: Buffer) => NodeTimeResponse;
    };
};
export interface UtilPublicServiceServer extends UntypedServiceImplementation {
    getNodeTime: handleUnaryCall<Empty, NodeTimeResponse>;
}
export interface UtilPublicServiceClient extends Client {
    getNodeTime(request: Empty, callback: (error: ServiceError | null, response: NodeTimeResponse) => void): ClientUnaryCall;
    getNodeTime(request: Empty, metadata: Metadata, callback: (error: ServiceError | null, response: NodeTimeResponse) => void): ClientUnaryCall;
    getNodeTime(request: Empty, metadata: Metadata, options: Partial<CallOptions>, callback: (error: ServiceError | null, response: NodeTimeResponse) => void): ClientUnaryCall;
}
export declare const UtilPublicServiceClient: {
    new (address: string, credentials: ChannelCredentials, options?: Partial<ChannelOptions>): UtilPublicServiceClient;
    service: typeof UtilPublicServiceService;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
